﻿/**
 * 
 * 游戏的根容器，相当于一个boot程序。
 * （是唯一一个被Cocos系统预装载的Js文件）
 * （原则上这里就只负责加载脚本吧）
 * 
 * 会增加游戏具体类容的加载进度条
 * tyevlag
 */

//var WebSocket = WebSocket || window.WebSocket || window.MozWebSocket;

var GameRootScene = cc.Scene.extend({
	// 是否发布版
	bRelease:false,
	aEngineFiles:null,
	hotUpdatePanel:null,
	_jsList:null,
	_loadJsIndex:0,
    onEnter:function () {

        this._super();
		cc.director.setDisplayStats(GameConfig.type == 0);
		//背景层
		this.loadBg = new cc.Sprite("res/ui/image/load/bg.jpg");
		this.loadBg.x = cc.visibleRect.width / 2;
		this.loadBg.y = cc.visibleRect.height / 2;
		this.addChild(this.loadBg);

		this.hotUpdatePanel = new HotUpdatePanel();
		this.addChild(this.hotUpdatePanel);

		// this.TimeUpdate( this.LoadGameScript, this, 0, 1 );
		//this.scheduleOnce( this.LoadGameScript, 0 );
    },
    
    /*
     * 加载全部游戏脚本
     */
    LoadGameScript:function() {
    	cc.log( "[ScriptInit] Begin" )
		var self = this;
    	if (this.bRelease){
    		// 发布版本加载整个包
			self._jsList = ["gameclient.js"];
			self.scheduleUpdate();
    	} else {
    		// 调试版本
    		cc.loader.loadJson("src/engine/enginejs.json", function(erre, enginefiles) {
    			if (erre) {
					zz.Error("[ScriptInit] enginejs.json Parse Error! " + erre.toString());
    			} else {
    				self.aEngineFiles = enginefiles;
    				cc.loader.loadJson("src/game/gamejs.json", function(errg, gamefiles) {
    					if (errg) {
							zz.Error("[ScriptInit] gamejs.json Parse Error! " + errg.toString());
    					} else {
	    					var aarr = [];
	    					var curarr = self.aEngineFiles.jsfiles;
	    					var len = curarr.length;
	    					var i = 0;
	    					for (i = 0; i < len; ++i) {
	    						if (curarr[i].indexOf("src") == 0)
	    							aarr.push(curarr[i]);
	    					}
	    					cc.log("aarr length " + aarr.length);

	    					curarr = gamefiles.jsfiles;
	    					len = curarr.length;
	    					for (i = 0; i < len; ++i) {
	    						if (curarr[i].indexOf("src") == 0)
	    							aarr.push(curarr[i]);
	    					}
	    					cc.log("aarr length " + aarr.length);
							self.scheduleUpdate();
							self._jsList = aarr;
    					}
    				});
    			}
    		});
    	}
    },
    
    _LoadGameScript:function(scriptarr){
    	cc.loader.loadJs("", scriptarr, function(err) {
    		if (!err) {

    		} else {
    			zz.Error("[ScriptInit] Parse Error! " + err.toString());
    		}
    	} );
    },

	update:function(dt) {
		//做个分帧加载, 加载卡住时间太长了体验不太好
		var start = new Date().getTime();
		while( this._loadJsIndex < this._jsList.length ){
			this._LoadGameScript(this._jsList.slice(this._loadJsIndex, this._loadJsIndex + 50));
			this._loadJsIndex += 50;
			this.hotUpdatePanel.LoadProgress( this._loadJsIndex / this._jsList.length * 100);
			var end = new Date().getTime();
			if( this._loadJsIndex > this._jsList.length ){
				cc.log("[ScriptInit] LoadScript Complete.");
				this._jsList.length = 0;
				GameMain.GameStart(this);
			}
			else if( end - start > 100 )
				return;
		}
		GameMain.OnFrame(dt);
	}
});

