/**
 * 游戏自定义事件
 * @author ty
 */

var EnumEventType = EnumEventType || {};
// 点击NPC
EnumEventType.GAME_MAP_NPC_SELECT  = "game_map_npc_select";
// 移动至目标 (带回调)
EnumEventType.GAME_MOVE_TO_TARGET = "game_move_to_target";
// 主玩家自动任务寻路结束
EnumEventType.GAME_AUTO_TASK_END_MOVE = "game_auto_task_end_move";
// 主玩家自动杀怪
EnumEventType.GAME_KILL_MONSTER = "game_kill_monster";
// 主玩家自动采集
EnumEventType.GAME_AUTO_COLLECT = "game_auto_collect";
// 主玩家移动结束
EnumEventType.GAME_END_MOVE = "game_end_move";


var GameEventMgr =  GameEventMgr || ({
	ndata : null,

	//事件监听
	AddEventListener:function (type, func, datadir, priority) {

		if (priority == null)
			priority = 1;

		//监听事件
		var _listener = cc.EventListener.create({
			event: cc.EventListener.CUSTOM,
			eventName: type,
			callback: function(event){
				func.call(datadir, event);
			}
		});
		cc.eventManager.addListener(_listener, priority);
	},

	DispatchEvent:function (type, data) {
		var event = new cc.EventCustom(type);
		event.data = data;
		cc.eventManager.dispatchEvent(event);
	},

	//移除监听
	RemoveEventListener:function (type , func) {
		EventCenter.GetEventCenter().removeEventListener(String(type), func);
	},

	Override:function clone() {
		return new GameEvent(this.ntype, this.ndata, this.nbubbles, this.ncancelable);
	}
});

