var DailyactivitiesModMgr = DailyactivitiesModMgr || cc.Class.extend({ 

	_activityHash:null,
	_keyHash:null,				//根据mainPanelKey分类好的
	_panelHash:null,			//mainPanelKey对应唯一面板

	ctor:function() {
		this._activityHash = new HashMap();
		this._keyHash = new HashMap();
		this._panelHash = new HashMap();

        SpecialDetailedInfo.prototype.reading = function( _buf ){
            this.type = _buf.ReadVarInt();
            //活动信息抽象的bytes 对应的是那几个特殊定义的info的bean
                switch( this.type )
                {
					case 1://充值活动信息
						this.beanInfo = _buf.ReadBean(RechargeActivityInfo);
						break;
					case 2://消费类型活动信息
						this.beanInfo = _buf.ReadBean(CostActivityInfo);
						break;
					case 3://简单条件类型活动信息
						this.beanInfo = _buf.ReadBean(ConditionActivityInfo);
						break;
					case 4://排行榜类型活动信息
						this.beanInfo = _buf.ReadBean(RankingActivityInfo);
						break;
					case 5://兑换
						this.beanInfo = _buf.ReadBean(ExchangeActivityInfo);
						break;
					case 6://天天充值
                        this.beanInfo = _buf.ReadBean(DailyRechargeActivityInfo);
						break;
					case 7://成就
                        this.beanInfo = _buf.ReadBean(AchievementActivityInfo);
						break;
				}
            }
	},

	RecvResActivitiesBriefInfoMessage:function(msg) {
		cc.log("收到活动 RecvResActivitiesBriefInfoMessage");
		this.reqTypeArr.length = 0;
		this._activityHash.Clear();
        var KFwarnState = false, SCwarnState = false, THwarnState = false;
		var reqIds = [];
		for( var i = 0, len = msg.activityBriefInfos.length; i < len; i++ ){
			var vo = new ActivityVo( msg.activityBriefInfos[i] );
			this._activityHash.Put( vo.activityId, vo );
			if(vo.status == 1){
				switch (vo.mainPanelKey) {
					case EnumActivityKey.M_KAI_FU:
                        KFwarnState = true;
						break;
                    case EnumActivityKey.M_SHOU_CHONG:
                        SCwarnState = true;
                        break;
					case EnumActivityKey.M_TE_HUI:
						THwarnState = true;
                        break;
				}
			}
			//这里检测活动的面板是否打开 是则刷新数据(先这样简单处理, 其实应该把多余活动删掉, 然后直接刷新面板之类)
			var panel = this._panelHash.Get(vo.mainPanelKey);
			if(Mgr.uiMgr.IsPanelShow(panel)){
				reqIds.push(vo.activityId);
			}
		}
		this._SortActivity();

		//更新活动入口按钮显示
        var panel = Mgr.map.miniMapPanel;
        panel.UpdateActivityButton(this._keyHash.Values());
        panel.UpdateKFWarn(KFwarnState);
        panel.UpdateSCwarn(SCwarnState);
        panel.UpdateTHWarn(THwarnState);
		//上线请求链接活动
		var data = ActivityUtil.GetGuideKeys();
		for(var i = 0, len = data.length; i < len; i++){
			var id = data[i];
			if(this._activityHash.ContainsKey(id)){
				reqIds.push(id);
			}
		}
        Mgr.dailyactivity.SendReqDailyActivitiesDetailedInfoMessage(reqIds, 1);
	},

	RecvResActivityDetailedInfoMessage:function(msg) {
        var allHash = new HashMap();
		var guideList = ActivityUtil.GetGuideKeys();
		for( var i = 0, len = msg.activityDetailedInfo.length; i < len; i++ ){
			var info = msg.activityDetailedInfo[i];
			var vo = this._activityHash.Get(info.baseInfo.activityId);
			if( vo ){
				vo.SetDetail(info);
				if( guideList.indexOf(info.baseInfo.activityId) == -1)	//跳转类活动不能根据自身key打开面板
					allHash.Put( vo.mainPanelKey, vo.mainPanelType );
			}
		}

		var reqType = this.reqTypeArr.length ? this.reqTypeArr.shift() : 0;
		var mainPanelKeys = allHash.Keys();
		for( var i = 0, len = mainPanelKeys.length; i < len; i++ ){
			var mainKey = mainPanelKeys[i];
			var mainType = allHash.Get(mainKey);
			var panel = this._panelHash.Get(mainKey);
			if( Mgr.uiMgr.IsPanelShow(panel) ){
				panel.SetActivityKey(mainKey, mainType);
			}
			else if (reqType == 0) {
				if( !panel ){
					var className = ActivityUtil.GetClassByMainType( mainType );
					panel = new className();
					panel._className = panel._className + (UIMgr.PanelNameIndex++);
					this._panelHash.Put(mainKey, panel);
				}
				Mgr.uiMgr.ShowPanel(panel);
				panel.SetActivityKey(mainKey, mainType, true);
			}
		}
	},

	RecvResActivityGetRewardResultInfoMessage:function(msg) {
		cc.log("getReward!!!!!");
		if( msg.result <= 0 )
			return;

		var vo = this._activityHash.Get(msg.activityDetailedInfo.baseInfo.activityId);
		if( vo ){
			vo.SetDetail(msg.activityDetailedInfo);

			var warn = false;
            if(vo.status == 1)
                warn = true;
            switch (vo.mainPanelKey) {
                case EnumActivityKey.M_KAI_FU:
                    Mgr.map.miniMapPanel.UpdateKFWarn(warn);
                    break;
                case EnumActivityKey.M_SHOU_CHONG:
                    Mgr.map.miniMapPanel.UpdateSCwarn(warn);
                    break;
            }
            //这里检测活动的面板是否打开 是则刷新数据
			var panel = this._panelHash.Get(vo.mainPanelKey);
            if(Mgr.uiMgr.IsPanelShow(panel)){
                panel.UpdateSingleActivity(vo);
            }
		}
	},

	RecvResDailyActivitiesRefreshMessage:function(msg) {
		this.SendReqDailyActivitiesBriefInfoMessage();
	},

	/**
	 * 请求活动列表
	 * @constructor
	 */
	SendReqDailyActivitiesBriefInfoMessage:function() {
		var msg = new ReqDailyActivitiesBriefInfoMessage();
		Mgr.msgMgr.Send(msg);
	},

	/**
	 * 请求活动详情
	 * @param ids []
	 * @constructor
	 */
	reqTypeArr:[],
	SendReqDailyActivitiesDetailedInfoMessage:function(ids, type) {
		type = type || 0;		// 0 打开面板   1 收到简要信息请求的 只刷新面板和数据
		if( ids && ids.length ){
			var msg = new ReqDailyActivitiesDetailedInfoMessage();
			msg.activityId = ids;
			Mgr.msgMgr.Send(msg);
			this.reqTypeArr.push(type);
		}
	},

	/**
	 * 请求领奖
	 * @param id
	 * @param count
	 * @constructor
	 */
	SendReqDailyActivitiesGetRewardMessage:function(id, count) {
		count = count || 1;
		var msg = new ReqDailyActivitiesGetRewardMessage();
		msg.activityId = id;
		msg.times = count;
		Mgr.msgMgr.Send(msg);
	},

	/**
	 * 活动根据mainPanelKey进行分类 打开面板的时候好取得对应的活动
	 * @constructor
	 */
	_SortActivity:function(){
		this._keyHash.Clear();
		var arr = this._activityHash.Values();
		var group;
		var activity;
		for( var i = 0, len = arr.length; i < len; i++ ){
			activity = arr[i];
			group = this._keyHash.Get(activity.mainPanelKey);
			if( group ){
				group.push(activity);
			}
			else{
				group = [activity];
				this._keyHash.Put(activity.mainPanelKey, group);
			}
		}
	},

	GetActivityByKey:function(key){
		return this._keyHash.Get(key);
	}
});
var ActivityVo = ActivityVo || cc.Class.extend({
		activityId:0,			//id
		activityType:0,			//活动类型
		groupType:0,			//活动分组	图标过多的时候 将同一类型的做到一个group里 点击后再显示该类的图标
		startTime:0,			//开始时间
		endTime:0,				//结束时间
		overTime:0,				//剩余秒数
		repeatTimes:0,			//剩余可领次数
		activityIcon:null,		//入口图标
		durationStr:null,		//活动时间文本

		activityName:null,		//活动名称
		activityReward:null,	//活动奖励
		status:2,				//活动状态	0 已领取 1 可领取 2 不可领取
		rewardTimes:0,			//已经领取次数
		allTimes:0,				//总共可领取次数
		introduction:null,		//活动介绍
		top:0,					//面板排序值
		tabKey:0,				//分页key
		resFlag:null,			//title图片 兑换次数等资源配置 每个类型的活动自己处理对应的值
		activityImgName:null,	//分页image
		tabType:0,				// 0文本 1美术字
		tabName:null,			// 分页tabBtn文本或美术路径
		titleType:0,			// 0文本 1美术字
		titleName:null,			// 面板标题 文本或美术路径
		special:null,			//条件 排行榜 充值 消费等特殊信息
		thirdPanelKey:0,
		thirdPanelName:null,

		mainPanelKey:0,			//主面板key  唯一标志 一组活动一个按钮入口
		mainPanelType:0,		//主面板类型 面板样式
		subPanelType:0,			//子面板类型

		ctor:function(info){
			this.activityId = info.activityId;
			this.activityType = info.activityType;
			this.groupType = info.groupType;

			this.startTime = info.startTime;
			this.endTime = info.endTime;
			this.overTime = info.overTime;
			this.repeatTimes = info.repeatTimes;

			this.mainPanelKey = info.mainPanelKey;
			this.activityIcon = info.entranceIcon;
			this.mainPanelType = info.mainPanelType;
			this.subPanelType = info.childPanelType;
			this.tabKey = info.activityTabKey;
            this.status = info.status;
			if (info.startTime == 0 || info.endTime == 0){
				this.durationStr = "永久";
			}
			else{
				this.durationStr = TimeUtil.GetDateStr(info.startTime) + " - " + TimeUtil.GetDateStr(info.endTime);
			}

		},
		SetDetail:function(info){
			this.activityName = info.baseInfo.activityName;
			this.activityReward = info.baseInfo.activityReward;
			this.status = info.baseInfo.status;
			this.rewardTimes = info.baseInfo.rewardTimes;
			this.allTimes = info.baseInfo.allTimes;
			this.introduction = info.baseInfo.info;
			this.top = info.baseInfo.top;
			this.tabKey = info.baseInfo.activityTabKey;
            if(info.baseInfo.resflag){
                this.resFlag = this._ParseFlag(info.baseInfo.resflag);
			}
			this.activityImgName = info.baseInfo.activityImgName;
			var arr = info.baseInfo.activityTabName.split(":");
			this.tabType = parseInt(arr[0]);
			this.tabName = arr[1];
			arr = info.baseInfo.titleUrl.split(":");
			this.titleType = parseInt(arr[0]);
			this.titleName = arr[1];
			this.special = info.specialDetaileds;
			if(info.baseInfo.thirdPanel){
                arr = info.baseInfo.thirdPanel.split(":");
                this.thirdPanelKey = arr[0];
                this.thirdPanelName = arr[1];
			}
		},

		_ParseFlag:function(flag){
			var hash = new HashMap();
			var flagArr = flag.split(",");
			for( var i = 0, len = flagArr.length; i < len; i++ ){
				flag = flagArr[i];
				var keyValue = flag.split(":");
				if( keyValue.length == 2 )
					hash.Put(keyValue[0], keyValue[1]);
			}
			return hash;
		},

		GetFlagValue:function (str) {
			if(!this.resFlag){
				return null;
			}
			return this.resFlag.Get(str);
        },

		GetRewardList:function () {
			var self = this;
            var awards = JSON.parse(self.activityReward);
            return awards;
        },

		IsEnd:function(){
			return this.endTime > 0 && this.endTime < ( Mgr.login.GetServerTime() / 1000 );
		}
	});

var EnumActivityFlag = EnumActivityFlag || {};
EnumActivityFlag.F_NEW_PRICE = "newprice";		//当前价格
EnumActivityFlag.F_CORRELATION = "correlation";		//关联过滤活动
EnumActivityFlag.F_POWER = "power"; 
EnumActivityFlag.F_BACKGROUND = "background";
EnumActivityFlag.F_GUIDE = "guide";		//跳转活动key
EnumActivityFlag.F_VIP = "vip";			//需要vip等级
EnumActivityFlag.F_LIMIT = "limit";		//根据status分段显示

var EnumActivityKey = EnumActivityKey || {};		//主面板类型
EnumActivityKey.M_KAI_FU = 1;			//开服活动(其实现在是与精彩活动共用一个)
EnumActivityKey.M_SHOU_CHONG = 2;		//首冲
EnumActivityKey.M_TE_HUI = 6;		//特惠礼包

var EnumActivityType = EnumActivityType || {};		//主面板模板类型
EnumActivityType.M_DEFAULT = 1;			//通用面板
EnumActivityType.M_SHOU_CHONG = 4;		//首冲豪礼
EnumActivityType.M_TE_HUI = 6;			//特惠礼包

EnumActivityType.S_TUAN_GOU = 56;                //团购等待页签的
EnumActivityType.S_CHOU_JIANG = 3;              //幸运抽奖
EnumActivityType.S_DOUBLE_RECHARGE = 12;        //双倍返利

var ActivityUtil = ActivityUtil || {
	Filter_Data:null,		// [[filterMainType],[filterSubType],[GuideId]]
	_guideHash:null,

    GetClassByMainType:function( mainType ){
        var className = ActivitiesBackGroundExt;
        switch( mainType ){
			case EnumActivityType.M_DEFAULT:
				className = ActivitiesBackGroundExt;
				break;
			case EnumActivityType.M_SHOU_CHONG:
				className = ShouChongMainExt;
				break;
			case EnumActivityType.M_TE_HUI:
				className = TeHuiLiBaoPanelExt;
				break;

		}
        return className;
    },

    GetClassBySubType:function( subType ){
        var name = CommonPanel.PanelName;
        switch (subType){
            case EnumActivityType.S_TUAN_GOU:
                name = TuangouMainExt.PanelName;
                break;
            case EnumActivityType.S_CHOU_JIANG:
                name = ChouJiangMainExt.PanelName;
                break;
        }
        return PanelClassDic[name];
    },

	//需要跳转的mainPanelKey
	GetGuideKeys:function(){
		if( this.Filter_Data )
			return this.Filter_Data[2];
		return [];
	},

	OpenGuidePanel:function (mainpanelkey, subpanelkey) {
		var acs =  Mgr.dailyactivity.GetActivityByKey(mainpanelkey);
		var reqIds = [];
		for(var i = 0, len = acs.length; i < len; i++){
			var ac = acs[i];
			reqIds.push(ac.activityId);
		}
		Mgr.dailyactivity.SendReqDailyActivitiesDetailedInfoMessage(reqIds);
		if( !this._guideHash )
			this._guideHash = new HashMap();
		this._guideHash.Put(mainpanelkey, subpanelkey);
	},
	//取得要跳转到的子标签
	GetGuideSubKey:function(mainPanelKey){
		var subKey = 0;
		if( this._guideHash ){
			subKey = this._guideHash.Get(mainPanelKey);
			this._guideHash.Remove(mainPanelKey);
		}
		return subKey;
	},

	/**
	 * 获得面板内活动的标签并按标签分组
	 * @param mainPanelKey
	 * @returns {HashMap}
	 * @constructor
	 */
    GetHashByTabKey:function(mainPanelKey){
		var hash = new HashMap();
		var list = Mgr.dailyactivity.GetActivityByKey(mainPanelKey);
		return this.GetTabHashByKey( list, "tabKey" );
	},

    /**
     * 获得面板内活动的标签并按标签分组
     * @param mainPanelKey
     * @returns {HashMap}
     * @constructor
     */
    GetTabHashByKey:function(list, keyName){
        var hash = new HashMap();
        keyName = keyName || "tabKey";
        if( list ){
            var arr;
            var activity;
            for(var i = 0, len = list.length; i < len; i++){
                activity = list[i];
                arr = hash.Get(activity[keyName]);
                if(arr){
                    arr.push(activity);
                }else {
                    arr = [activity];
                    hash.Put(activity[keyName], arr);
                }
            }
        }
        return hash;
    },

	//过滤后的活动
	GetListByCorrelation:function (infoList) {
		var arr = [];
		for(var i = 0, len = infoList.length; i < len; i++){
			var info = infoList[i];
			var correlation = info.GetFlagValue(EnumActivityFlag.F_CORRELATION);
            if( !this.IsClearByCorrelation(correlation, infoList) && !this.IsOtherCorrelationClear(info, infoList) ){
                arr.push(info);
            }
		}
		return arr.sort(function (a, b) { return a.top - b.top;});
	},

	//根据显示条件进行过滤
    IsClearByCorrelation:function (correlation, list) {
		if(!correlation){
			return false;
		}
        correlation = parseInt(correlation);
		for(var i = 0, len = list.length; i < len; i++){
			var info = list[i];
			if(info.activityId == correlation){
                if( info.rewardTimes < info.allTimes ){
                    return true;
                }
				break;
			}
		}
		return false;
	},

	IsOtherCorrelationClear:function (info, list) {
        for(var i = 0, len = list.length; i < len; i++){
            if(parseInt( list[i].GetFlagValue("correlation") ) == info.activityId ){
                if(info.rewardTimes >= info.allTimes){
                    return true;
                }
                break;
            }
        }
		return false;
	},
	SortByStatus:function(vo1, vo2){
		if( vo1.status == 0 ){
			return vo2.status - 0;
		}
		else if( vo1.status == 1 ){
			return -1;
		}
		else{
			return vo2.status == 1 ? 1 : -1;
		}
	},
	GetLimitList:function(list){
		var startIndex = 0;
		var endIndex = 0;
		for( var i = 0, len = list.length; i < len; i++ ){
			var vo = list[i];
			if( vo.GetFlagValue(EnumActivityFlag.F_LIMIT) != null ){
				if( vo.status == 0 ){
					startIndex = i+1;
				}
				else{
					endIndex = i;
					break;
				}
			}
		}
		return list.slice( startIndex, endIndex - startIndex + 1 );
	}
}