/**
 * equip up Util
 */
var DuanzaoUtil = DuanzaoUtil || {
    //* 取得装备战斗力
    GetEquipFighting:function ( mid, lv ) {
        var fighting = 0;
        var attrV = this.GetAttributeV( mid, lv );
        if(!attrV)
            return 0;
        var fo = Mgr.attributeMgr.GetAttributeRate(attrV.type, 0);
        if ( fo )
            fighting = fo * attrV.value;

        return fighting;
    },

    //* 取得装备属性
    GetAttributeV:function ( mid, lv ) {
        var type , attr, str;
        var attrV = null;

        // base value
        var propObj = Q_item_simpact.Get( mid );
        cc.assert(null != propObj, "data is unexist in Q_item_simpact!  mid: " + mid);
        if ( propObj.q_attribute  ) {
            var str2 = ParseUtil.FormatFastJsonStr(propObj.q_attribute);
            var jsonData = JSON.parse(str2);
            var array = [];
            for (var keyStr in jsonData) {
                array.push([parseInt(keyStr), parseInt(jsonData[keyStr])]);
            }

            if (array[0][0] == EnumAttribute.MAX_BASEHP) {
                type = EnumAttribute.MAX_BASEHP
                str = "生命";
            }
            else if (array[0][0] == EnumAttribute.ATTACK) {
                type = EnumAttribute.ATTACK
                str = "攻击";
            }
            else if (array[0][0] == EnumAttribute.DEFEND) {
                type = EnumAttribute.DEFEND
                str = "防御";
            }
            else if (array[0][0] == EnumAttribute.HIT) {
                type = EnumAttribute.HIT
                str = "命中";
            }
            else if (array[0][0] == EnumAttribute.DODGE) {
                type = EnumAttribute.DODGE
                str = "闪避";
            }
            else if (array[0][0] == EnumAttribute.CRIT) {
                type = EnumAttribute.CRIT
                str = "暴击";
            }
            else if (array[0][0] == EnumAttribute.ANTI_CRIT) {
                type = EnumAttribute.ANTI_CRIT
                str = "抗暴击";
            }
            attr = array[0][1];

            // up value
            if (lv > 0) {
                var sid = String(String(mid) + '_' + String(lv));
                var q_attribute_rise = Q_attribute_rise.Get(sid);
                //cc.assert(null != q_attribute_rise, "data is unexist in Q_attribute_rise!  sid: " + sid);
                if (q_attribute_rise && q_attribute_rise.q_attribute) {
                    var str1 = ParseUtil.FormatFastJsonStr(q_attribute_rise.q_attribute);
                    jsonData = JSON.parse(str1);
                    for (var keyStr in jsonData) {     //加起来 强化表里是增量 --merlin
                        var key = parseInt(keyStr);
                        for (var i = 0; i < array.length; i++) {
                            if (array[i][0] == key) {
                                array[i][1] += parseInt(jsonData[keyStr]);
                                break;
                            }
                        }
                    }
                    attr = array[0][1];
                }
            }
            attrV = { type:type, value:attr, str:str };
        }
        return attrV;
    },

    //* 是否属于 升级装备
    IsUpGoods:function ( mid ) {
        var typeObj = Q_item.Get( mid );
        cc.assert(null != typeObj, "data is unexist in Q_item!  mid: " + mid);
        if ( typeObj.q_max_strengthen <= 0 )
            return false;
        return true;
    },

    //* 是否达到升级条件
    IsFullCondition:function ( equipV, autoBuy ) {
        //unEnable up
        var mid = equipV.itemModelId;
        if ( !DuanzaoUtil.IsUpGoods( mid ) )
            return UpMrakEnum.UP_UN_UP;

        //max level
        if ( equipV.strenthenLv >= Q_item.Get(mid).q_max_strengthen )
            return UpMrakEnum.UP_MAX_LEVEL;

        var sid = String( String( mid ) + '_' + String( equipV.strenthenLv + 1 ) );
        var q_attribute_rise = Q_attribute_rise.Get( sid);
        cc.assert(null != q_attribute_rise, "data is unexist in Q_attribute_rise!  sid: " + sid);

        //gold shortage   ( 留着吧，以后可能会要消耗英两 )
        // var shortGold = Mgr.mainPlayer.attributeData.TotalMoney() < q_attribute_rise.q_up_gold_num;
        // if ( shortGold ) {
        //     cc.log("gold shortage!!!");
        //     return false;
        // }

        //material shortage
        var num = Mgr.backpack.GetItemNumber( q_attribute_rise.q_up_item_id, true );
        var shortMaterial = num < q_attribute_rise.q_up_item_num;
        if ( shortMaterial ) {
            //auto buy material
            if ( !autoBuy )
                return UpMrakEnum.UP_SHORT_MATERIAL;

            var dev_num = q_attribute_rise.q_up_item_num - num;
            // 单价
            var idArr= JSON.parse( Q_global.Get( 1003 ).q_string_value );
            var single_price = 0;
            for (var i = 0; i < idArr.length; i++)
            {
                var mid = parseInt(idArr[i][0]);
                if ( mid == q_attribute_rise.q_up_item_id ) {
                    single_price = parseInt(idArr[i][1]);
                    break;
                }
            }

            var prices = single_price * dev_num;
            var rest_prices = Mgr.mainPlayer.attributeData.TotalGold() - prices;
            if ( rest_prices < 0 )
                return UpMrakEnum.UP_SHORT_GOLD;

            //( 留着吧，以后可能会要消耗英两 )
            // if ( rest_prices < q_attribute_rise.q_up_gold_num ) {
            //     cc.log("up money shortage!!!");
            //     return false;
            // }
        }
        return UpMrakEnum.UP_EN_UP;
    },

    //* 宝石格子开启条件列表
    GetStoneCondition: function() {
        var stoneEnum = [];
        var idArr= JSON.parse( Q_global.Get( 1004 ).q_string_value );
        for (var i = 0; i < idArr.length; i++)
        {
            var type = parseInt(idArr[i][1]);
            var preLevel = parseInt(idArr[i][0]);
            var mark = { type:type, preLevel:preLevel, pos:(i+1) };
            stoneEnum.push( mark );
        }
        return stoneEnum;
    },

    //* 取得装备的操作mark
    GetEquipGridMark: function ( equipType ) {

        var boo_replace = false;
        var boo_inlay = false;

        var equipV = null;
        var equips = Mgr.player.mainPlayer.equips;
        for ( var i = 0; i < equips.length; i++ ) {
            var equipC = Q_item.Get(equips[i].itemModelId);
            if ( equipC.q_kind == equipType ) {
                equipV = equips[i];
                break;
            }
        }
        if ( !equipV )
            return StoneGridMarkEnum.NORMAL;

        if ( equipV.strenthenLv <= 0 )
            return StoneGridMarkEnum.NORMAL;

        // 是否达到开启等级
        var stoneTypeEnum = [StoneAttributeEnum.ATTACK, StoneAttributeEnum.DEFENSE,StoneAttributeEnum.HP];
        for ( var i = 0; i != stoneTypeEnum.length; i++ ) {
            var stoneType = stoneTypeEnum[i];
            var markV = DuanzaoUtil.GetStoenGridMarkV( equipType, stoneType );
            if ( markV.type == StoneGridMarkEnum.REPLACE )
                boo_replace = true;
            else if ( markV.type == StoneGridMarkEnum.INLAY )
                boo_inlay = true;
        }

        if ( boo_inlay )
            return StoneGridMarkEnum.INLAY;
        else if ( boo_replace )
            return StoneGridMarkEnum.REPLACE;
        else
            return StoneGridMarkEnum.NORMAL;
    },

    //* 取得镶嵌格子的markV
    GetStoenGridMarkV:function ( equipType, stoneType ) {

        var type = null, str = null, unload = false;
        var markV = {str: "", type: StoneGridMarkEnum.NORMAL, unload : false};

        var stoneC = null;
        var stoneData = Mgr.gem.GetInlayStone(equipType, stoneType);
        if ( stoneData )
            stoneC = stoneData.stoneC;

        if (!stoneC) {   //  可镶嵌
            str = "镶嵌";
            type = StoneGridMarkEnum.UNINLAY;
            unload = false;

            var list = Mgr.backpack.GetItemsByType(EnumItemType.GEM, true);
            for (var i = 0; i != list.length; i++) {
                var itemV = Q_item.Get(list[i].itemModelId);
                cc.assert(null != itemV, "data is unexist in Q_item!  mid: " + list[i].itemModelId);
                //判断镶嵌材料是否存在
//                if (stoneType == itemV.q_location && itemV.q_rank == 1) {
                if (stoneType == itemV.q_location ) {
                    type = StoneGridMarkEnum.INLAY;
                    break;
                }
            }
        }
        else {
            str = "拆卸";
            // type = StoneGridMarkEnum.UNUP;
            // type = StoneGridMarkEnum.REMOVE;
            unload = true;

            var list = Mgr.backpack.GetItemsByType(EnumItemType.GEM, true);
            for (var i = 0; i != list.length; i++) {
                var itemV = Q_item.Get(list[i].itemModelId);
                cc.assert(null != itemV, "data is unexist in Q_item!  mid: " + list[i].itemModelId);
                //判断升级材料是否存在
                if (stoneType == itemV.q_location && (stoneC.q_rank < itemV.q_rank) && list[i].itemNum >= 1) {
                    // type = StoneGridMarkEnum.UP;
                    type = StoneGridMarkEnum.REPLACE;
                    break;
                }
            }
        }

        // 关联装备进行判断
        var equipV = null;
        var equips = Mgr.player.mainPlayer.equips;
        for ( var i = 0; i < equips.length; i++ ) {
            var equipC = Q_item.Get(equips[i].itemModelId);
            cc.assert(null != equipC, "data is unexist in Q_item!  mid: " + equips[i].itemModelId);
            if ( equipC.q_kind == equipType ) {
                equipV = equips[i];
                break;
            }
        }
        if ( !equipV ) {   //不存在装备，直接不显示按钮
            markV = {str: "", type: StoneGridMarkEnum.NORMAL, unload : unload};
        }
        else {
            var stoneEnum = this.GetStoneCondition();
            for ( var i = 0; i != stoneEnum.length; i++ ) {
                if ( stoneType == stoneEnum[i].type ) {
                    if ( equipV.strenthenLv >= stoneEnum[i].preLevel )  // 装备等级达标
                         markV = {str: str, type: type, unload : unload};
                    else
                        markV = {str: str, type: StoneGridMarkEnum.UNOPEN, unload : unload};
                    break;
                }
            }
        }
        return markV;
    },

    // * 判断具体摸个宝石能否合成
    IsEnableHecheng:function ( stoneLocation, lv ) {
        var list = this.GetEnableComposeStone();
        for ( var i = 0; i != list.length; i++ ) {
            if ( list[i].q_location == stoneLocation && list[i].q_rank == lv ) {
                return true;
            }
        }
        return false;
    },

    //* 获取可合成的宝石列表
    GetEnableComposeStone:function ( location, level ) {
        location = arguments.length > 0 ? parseInt(location):-1;
        level = arguments.length > 1 ? parseInt(level):-1;

        var hcList = [];
        var list = this.GetStoneByType( EnumItemType.GEM );
        for ( var i = 0; i != list.length; i++ ) {
            //判断是否可合成
            if ( Mgr.backpack.GetItemNumber(  list[i].q_id ) >= 3 ) {
                var lv = list[i].q_rank + 1;
                if ( lv <= Mgr.refining._maxStoneLv ) { 
                    //找出下一个
                    for ( var j = 0; j != list.length; j++ ) {
                        if ( list[j].q_location == list[i].q_location && list[j].q_rank == lv ) {
                            if ( (location == list[j].q_location || location == -1) && ( level == list[j].q_rank || level == -1 ) ) {
                                hcList.push(list[j]);
                                break;
                            }
                        }
                    }
                }
            }
        }
        return hcList;
    },

     //* 通过type获取Q_item
    GetStoneByType:function ( type, location ) {
        location = location || -1;
        var hcList = [];
        var list = Q_item.GetList();
        for ( var i = 0; i != list.length; i++ ) {
            if ( list[i].q_type == type && (location == list[i].q_location || location == -1) ) {
                hcList.push( list[i] );
            }
        }
        return hcList;
    },

     //* 通过装备品质取得精炼石最大数量
    GetRefineStoneNumByQuility:function ( quility ) {
        var data = null;
        var idArr = JSON.parse( Q_global.Get( 1005 ).q_string_value );
        for ( var i = 0; i != idArr.length; i++ ) {
            if ( parseInt(idArr[i][0]) == quility ) {
                data = [
                    { location:parseInt(idArr[i][1]), num:parseInt(idArr[i][2]) },
                    { location:parseInt(idArr[i][3]), num:parseInt(idArr[i][4]) },
                    { location:parseInt(idArr[i][5]), num:parseInt(idArr[i][6]) },
                ];
                break;
            }
        }
        return data;
    },

     //* 获取指定装备的精炼石信息stoneHash
    GetRefineStoneHash:function ( mid ) {
        var refineHash = new HashMap();
        var stoneTypeEnum = [RefineStoneEnum.ATTACK, RefineStoneEnum.DEFENSE,RefineStoneEnum.HP];
        for (var i = 0; i != stoneTypeEnum.length; i++) {
            var itemC = null;
            var configList = this.GetStoneByType(EnumItemType.RefineStone, stoneTypeEnum[i]);
            if (configList.length > 0)
                itemC = configList[0];

            //获取该品质可精炼数量上限
            var maxNum = 0;
            var equipC = Q_item.Get(mid);
            cc.assert(null != equipC, "data is unexist in Q_item!  mid: " + mid);
            var data = DuanzaoUtil.GetRefineStoneNumByQuility(equipC.q_rank);
            if (data) {
                for (var j = 0; j != data.length; j++) {
                    if (stoneTypeEnum[i] == data[j].location) {
                        maxNum = data[j].num;
                        break;
                    }
                }
            }
            // 已经使用的数量
            var usedNum = 0;
            var cache = Mgr.equipRefine.GetRefineStones(255);
            for (var j = 0; j != cache.length; j++) {
                if (cache[j].equipLocation == equipC.q_kind) {
                    var list = cache[j].refinelList;
                    for (var k = 0; k != list.length; k++) {
                        if (list[k] == itemC.q_id) {
                            usedNum = list[k + 1];
                            break;
                        }
                    }
                    break;
                }
            }
            // 背包拥有数量
            var bagNum = 0;
            var bagList = Mgr.backpack.GetItemsByMid( itemC.q_id, true );
            for ( var j = 0; j != bagList.length; j++ ) {
                bagNum += bagList[j].itemNum;
            }

            var location = stoneTypeEnum[i];
            var obj = { item:itemC, bagNum:bagNum, maxNum:maxNum, usedNum:usedNum };
            refineHash.Put( parseInt(location), obj );
        }
        return refineHash;
    },

     //* 获取装备精炼mark
    GetRefineMark:function ( mid ) {
        var max_refine = false;
        var max_quality = false;
        var en_refine = false;

        var hash = this.GetRefineStoneHash( mid );
        var list = hash.Values();
        for ( var i = 0; i != list.length; i++ ) {
            // 满品质
            var equipC = Q_item.Get( mid );
            cc.assert(null != equipC, "data is unexist in Q_item!  itemModelId: " + mid);
            if ( equipC.q_rank >= 10 ) // 目前最大品质10
                max_quality = true;

            // 满精炼
            if ( list[i].maxNum <= list[i].usedNum )
                max_refine = true;
            else if ( list[i].bagNum > 0 )
                en_refine = true;
        }

        if ( en_refine )
            return RefineMrakEnum.EN_REFINE;
        else if ( max_refine ) {
            if ( !max_quality )
                return RefineMrakEnum.MAX_REFINE;
            else
                return RefineMrakEnum.MAX_REFINE_AND_QUILITY;
        }
        else
            return RefineMrakEnum.UN_BAGNUM;
    },

    // * 判断当前装备是否可以精炼
    IsEnableRefine:function ( mid ) {
        var hash = this.GetRefineStoneHash( mid );
        var list = hash.Values();
        for ( var i = 0; i != list.length; i++ ) {
            if ( (list[i].maxNum > list[i].usedNum)  && (list[i].bagNum > 0) )
                return true;
        }
        return false;
    },

        /***
         * 是否存在叹号操作
         * @param subType
         * @returns {boolean}
         * @constructor
         */
    IsMarkBySubType:function ( subType ) {
        var equipTypeList = [
            EnumEquipPos.EQUIP_WEAPONS,//武器0
            EnumEquipPos.EQUIP_CLOTHES,//衣服3
            EnumEquipPos.EQUIP_HUTUI,//护腿4
            EnumEquipPos.EQUIP_HUFU_LEFT,//左护符6
            EnumEquipPos.EQUIP_RING_LEFT,//左戒指8
            EnumEquipPos.EQUIP_BELT,  //腰带3
            EnumEquipPos.EQUIP_BRACELET_LEFT,//手镯2
            EnumEquipPos.EQUIP_SHOES, //鞋子5
            EnumEquipPos.EQUIP_HUFU_RIGHT, //右护符7
            EnumEquipPos.EQUIP_RING_RIGHT //右戒指9
        ];

        //强化
        if ( subType == undefined || subType == DuanzaoTypeEnum.EQUIP_UP ) {
            var checkbox = false;
            var panel = Mgr.uiMgr.GetPanelByType(DuanzaoPanelExt.PanelName);
            if ( panel ) {
                var page = panel.panelMgr[DuanzaoTypeEnum.EQUIP_UP];
                if ( page ) {
                    checkbox = page._GetAuoBuyState();
                }
            }

            var equips = Mgr.player.mainPlayer.equips;
            for (var i = 0; i != equipTypeList.length; i++) {
                for ( var j = 0; j < equips.length; j++ ) {
                    var equipC = Q_item.Get(equips[j].itemModelId);
                    cc.assert(null != equipC, "data is unexist in Q_item!  mid: " + equips[j].itemModelId);
                    if (equipC.q_kind == equipTypeList[i]) {
                        if (DuanzaoUtil.IsFullCondition(equips[j], checkbox) == UpMrakEnum.UP_EN_UP) {
                            return true;
                        }
                        break;
                    }
                }
            }
        }

        //镶嵌
        if ( subType == undefined ||  subType == DuanzaoTypeEnum.EQUIP_INLAY ) {
            for ( var i = 0; i != equipTypeList.length; i++ ) {
                var mark = DuanzaoUtil.GetEquipGridMark( equipTypeList[i] );
                if ( mark != StoneGridMarkEnum.NORMAL ) {
                    return true;
                }
            }
        }

        // 合成
        if ( subType == undefined ||  subType == DuanzaoTypeEnum.EQUIP_COMPOSE ) {
           var list = DuanzaoUtil.GetEnableComposeStone();
            if ( list.length > 0 ) {
                return true;
            }
        }

        // 熔炼
        if ( subType == undefined ||  subType == DuanzaoTypeEnum.EQUIP_MELTING ) {
            // shortPanel
            var checkbox = true;
            var level = 0;
            var panel = Mgr.uiMgr.GetPanelByType( DuanzaoPanelExt.PanelName );
            if ( panel ) {
                var page = panel.panelMgr[DuanzaoTypeEnum.EQUIP_MELTING];
                if ( page ){
                    checkbox = page._GetAuoSelectState();
                    level = page.selectLevel;
                }
                else{
                    checkbox = true;
                    level = 4;
                }
            }
            else{
                checkbox = true;
                level = 4;
            }
            var list = DuanzaoUtil.FilterEquip( checkbox, level );
            if ( list.length > 0 ) {
                return true;
            }
        }

        // 精炼
        if ( subType == undefined ||  subType == DuanzaoTypeEnum.EQUIP_REFINE ) {
            var equips = Mgr.player.mainPlayer.equips;
            for ( var j = 0; j < equips.length; j++ ) {
                var equipC = Q_item.Get(equips[j].itemModelId);
                if ( equipC ) {
                    for (var i = 0; i != equipTypeList.length; i++) {
                        if (equipC.q_kind == equipTypeList[i]) {
                            if (DuanzaoUtil.IsEnableRefine(equips[j].itemModelId)) {
                                return true;
                            }
                            break;
                        }
                    }
                }
                else {
                    zz.Error("读取配置表（Q_item）数据出错，key：  " + equips[j].itemModelId)
                }
            }
        }

        //套装
        if ( subType == undefined ||  subType == DuanzaoTypeEnum.EQUIP_SUIT ) {
            var equips = Mgr.player.mainPlayer.equips;
            for ( var j = 0; j < equips.length; j++ ) {
                var equipC = Q_item.Get(equips[j].itemModelId);
                if ( !equipC ) {
                    zz.Error("读取配置表（Q_item）数据出错，key：  " + equips[j].itemModelId)
                }
                else {
                    for (var i = 0; i != equipTypeList.length; i++) {
                        if (equipC.q_kind == equipTypeList[i]) {

                            var ifRank = !SuitMakeUtil.IsShortRank(equips[j].itemModelId);  //品阶是否足够

                            var stars = Mgr.equipRefine.GetSuitByLocation(equipC.q_kind);
                            var kind = equipC.q_kind;
                            var ifMax = SuitMakeUtil.IsMaxSuitStars(stars, kind);  // 是否满星
                            var ifSuit = SuitMakeUtil.CheckCycleSuits(kind, stars);  // 是否集齐一套
                            var ifMaterial = !SuitMakeUtil.IsShortMaterial(stars, kind);  // 材料是否足够
                            if ( ifRank && !ifMax && ifSuit && ifMaterial )
                                return true;
                            break;
                        }
                    }
                }
            }
        }
        return false;
    },

    // 筛选出推存熔炼的装备
    FilterEquip:function ( isFilter , level) {
        //新规则  智能熔炼不受参数影响 熔炼掉低于当前穿戴对应装备战斗力并且品质为红色以下装备(角色装备为橙色以下)\
        //0白色，1绿色，2蓝色，3紫色，4橙色，5红色，6粉色

        var isFilter = true;
        var list = [];
        var fighting = 0;

        var bagList = Mgr.backpack.GetItems();
        for ( var i = 0; i != bagList.length; i++ ) {
            var item = bagList[i];
            if ( !Q_item.Get(item.itemModelId) )
                continue;

            var fighting = 0;
            var type = Q_item.Get(item.itemModelId).q_type;
            if ( ItemUtil.IsEquip(type)) {
                var bFighting = DuanzaoUtil.GetEquipFighting(item.itemModelId, item._itemLevel);
                // 人物装备
                if ( type == EnumItemType.Equip ) {
                    var equipsHash = Mgr.equip.equipsHash;
                    var euqip = equipsHash.Get(Q_item.Get(item.itemModelId).q_kind);
                    if(euqip)
                        fighting = DuanzaoUtil.GetEquipFighting(euqip.itemModelId, euqip.strenthenLv);
                    if(Q_item.Get(item.itemModelId).q_default <= ItemUtil.ITEM_QT_PURPLE){
                        if(isFilter){
                            if (bFighting <= fighting){
                                this.PutList(item,list,bFighting,fighting);
                            }
                        }
                        else{
                            this.PutList(item,list,bFighting,fighting);
                        }
                    }
                    // var equips = Mgr.player.mainPlayer.equips;
                    // for (var j = 0; j < equips.length; j++) {
                    //     if (Q_item.Get(item.itemModelId).q_kind == Q_item.Get(equips[j].itemModelId).q_kind) {
                    //         // isfound = true;
                    //         fighting = DuanzaoUtil.GetEquipFighting(equips[j].itemModelId, equips[j].strenthenLv);
                    //         // if (bFighting < fighting)
                    //         //     lowList.push({index: -1, item: item});
                    //         // else if (bFighting == fighting) {
                    //         //     if (Q_item.Get(item.itemModelId).q_rank < Q_item.Get(equips[j].itemModelId).q_rank)
                    //         //         lowList.push({index: -1, item: item});
                    //         //     else if (Q_item.Get(item.itemModelId).q_rank == Q_item.Get(equips[j].itemModelId).q_rank)
                    //         //         midList.push({index: 0, item: item});
                    //         //     else
                    //         //         highList.push({index: 1, item: item});
                    //         // }
                    //         // else
                    //         //     highList.push({index: 1, item: item});
                    //
                    //
                    //         // if(Q_item.Get(item.itemModelId).q_default <= level){
                    //
                    //         break;
                    //     }
                    // }
                }

                //  资源线装备
                if ( type != EnumItemType.Equip ) {
                    var reslineTypes = [EnumResline.HORSE, EnumResline.GUANGWU,
                        EnumResline.DRAGON, EnumResline.SHUTONG, EnumResline.BAOQI];
                    for (var j = 0; j < reslineTypes.length; j++) {
                        var _mgr = Mgr.resline.GetMgrByType(reslineTypes[j]);
                        var resEquips = _mgr._equips;
                        if (!resEquips)
                            continue;
                        for (var m = 0; m != resEquips.length; m++) {
                            if (resEquips[m].itemModelId > 0 && type == Q_item.Get(resEquips[m].itemModelId).q_type
                                && Q_item.Get(item.itemModelId).q_kind == Q_item.Get(resEquips[m].itemModelId).q_kind) {
                                fighting = DuanzaoUtil.GetEquipFighting(resEquips[m].itemModelId, resEquips[m].strenthenLv);
                                // isfound = true;
                                // if (bFighting < fighting)
                                //     lowList.push({index: -1, item: item});
                                // else if (bFighting == fighting)
                                //     midList.push({index: 0, item: item});
                                // else
                                //     highList.push({index: 1, item: item});

                                // if(Q_item.Get(item.itemModelId).q_default > level){
                                if(Q_item.Get(item.itemModelId).q_default <= ItemUtil.ITEM_QT_ORANGE){
                                    if(isFilter){
                                        if (bFighting <= fighting){
                                            this.PutList(item,list,bFighting,fighting);
                                        }
                                    }
                                    else{
                                        this.PutList(item,list,bFighting,fighting);
                                    }
                                }
                                break;
                            }
                        }
                    }
                }
                // if ( !isfound )
                //     list.push({index:1,item:item});
            }
        }

        // var list = [];
        // if ( isFilter ) {
        //     list = lowList;
        // }
        // else {
        //     list = list.concat(lowList);
        //     list = list.concat(midList);
        //     list = list.concat(highList);
        // }
        // if(level != undefined){
        //     list = [];
        //     for(var i = 0; i <= level; i++){
        //         if(this["List"+i].length)
        //             list = list.concat(this["List"+i]);
        //     }
        // }
        return list;
    },

    PutList:function(item , list, bFighting, fighting){
        if (bFighting < fighting)
            list.push({index: -1, item: item});
        else if (bFighting == fighting)
            list.push({index: 0, item: item});
        else
            list.push({index: 1, item: item});
    },
};