var DuanzaoPanelExt = DuanzaoPanel.extend ( {
	_className:"DuanzaoPanelExt",

	panelMgr:null,
	showPanel:null,
	showType:null,

	_btnArr:null,
	_btnPosArr:null,

	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = -28;
		this._btnArr = [];
		this.panelMgr = {};
		this.showType = DuanzaoTypeEnum.EQUIP_UP;
	},

	Init:function() {
		var self = this;
		DuanzaoPanel.prototype.Init.call(this);
		this.SetPendantMovie(this.imgJian);

		this._InitParam();

		this.imgQianghua.addClickEventListener(function (event){
			self.ChangePanel( DuanzaoTypeEnum.EQUIP_UP );
		});
		this.imgXiangqian.addClickEventListener(function (event){
			self.ChangePanel( DuanzaoTypeEnum.EQUIP_INLAY );
		});
		this.imgHecheng.addClickEventListener(function (event){
			self.ChangePanel( DuanzaoTypeEnum.EQUIP_COMPOSE);
		});
		this.imgDuanzao.addClickEventListener(function (event){
			self.ChangePanel( DuanzaoTypeEnum.EQUIP_MELTING);
		});
		this.imgJinglian.addClickEventListener(function (event){
			self.ChangePanel( DuanzaoTypeEnum.EQUIP_REFINE );
		});
		this.imgSuit.addClickEventListener(function (event){
			self.ChangePanel( DuanzaoTypeEnum.EQUIP_SUIT );
		});

		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});
	},

	_InitParam:function () {
		this.imgTanhao.setVisible(false);
		this._btnArr = [
			{btn:this.imgQianghua,type:DuanzaoTypeEnum.EQUIP_UP},
			{btn:this.imgXiangqian,type:DuanzaoTypeEnum.EQUIP_INLAY},
			{btn:this.imgHecheng,type:DuanzaoTypeEnum.EQUIP_COMPOSE},
			{btn:this.imgDuanzao,type:DuanzaoTypeEnum.EQUIP_MELTING},
			{btn:this.imgJinglian,type:DuanzaoTypeEnum.EQUIP_REFINE},
			{btn:this.imgSuit,type:DuanzaoTypeEnum.EQUIP_SUIT},
		];
		this._btnPosArr = [
			this.imgQianghua.getPosition(),this.imgXiangqian.getPosition(),
			this.imgHecheng.getPosition(),this.imgDuanzao.getPosition(),
			this.imgJinglian.getPosition(),this.imgSuit.getPosition()
		];
	},

	ChangePanel:function ( type ){
		// statues
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			if ( this._btnArr[i].type == type )
				this._btnArr[i].btn.SetButtonState( "check" );
			else
				this._btnArr[i].btn.SetButtonState( "uncheck" );
		}

		if ( this.showPanel ) {
			this.showPanel.visible = false;
			if (this.showPanel.StopEffect)
				this.showPanel.StopEffect();
		}

		switch( type ){
			case DuanzaoTypeEnum.EQUIP_UP:
				if ( !this.panelMgr[type] ) {
					var panel = new QianhuaMainExt();
					panel.LoadPanel();
					this.imgTitleBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case DuanzaoTypeEnum.EQUIP_INLAY:
				if ( !this.panelMgr[type] ) {
					var panel = new XiangqianMainExt();
					panel.LoadPanel();
					this.imgTitleBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case DuanzaoTypeEnum.EQUIP_COMPOSE:
				if ( !this.panelMgr[type] ) {
					var panel = new HechengMainExt();
					panel.LoadPanel();
					this.imgTitleBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case DuanzaoTypeEnum.EQUIP_MELTING:
				if ( !this.panelMgr[type] ) {
					var panel = new RonglianMainExt();
					panel.LoadPanel();
					this.imgTitleBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case DuanzaoTypeEnum.EQUIP_REFINE:
				if ( !this.panelMgr[type] ) {
					var panel = new JinglianMainExt();
					panel.LoadPanel();
					this.imgTitleBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case DuanzaoTypeEnum.EQUIP_SUIT:
				if ( !this.panelMgr[type] ) {
					var panel = new SuitMakePanelExt();
					panel.LoadPanel();
					this.imgTitleBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
            case DuanzaoTypeEnum.EQUIP_CLOAK:
                if ( !this.panelMgr[type] ) {
                    var panel = new HuanhuaMainExt();
                    panel.LoadPanel();
                    this.imgTitleBg.addChild(panel);
                    this.panelMgr[type] = panel;
                }
                break;
			default:
				break;
		}
		this.showType = type;
		this.showPanel = this.panelMgr[type];
		if ( this.showPanel ) {
			this.showPanel.SetData();
			this.showPanel.visible = true;
			if (this.showPanel.AddEffect)
				this.showPanel.AddEffect();
		}
		return this.showPanel;
	},
	OnHide:function()
	{
		this._super();
		if ( this.showPanel ) {
			this.showPanel.visible = false;
			if (this.showPanel.StopEffect)
				this.showPanel.StopEffect();
		}
	},
	// 更新提醒
	UpdataWarn:function ( type ) {
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			var _type = this._btnArr[i].type;
			var _button = this._btnArr[i].btn;
			if ( type == undefined ||  _type == type ) {
				// main
				this.SetButtonWarn(_button, DuanzaoUtil.IsMarkBySubType( _type ));

				// sub
				var page = this.panelMgr[_type];
				if ( page && page.visible && page.UpdataWarn )
					page.UpdataWarn();
			}
		}
	},

	SetButtonWarn:function ( widget, warn ) {
		if ( !widget.warn ) {
			var icon = new MUIImage();
			icon.ParseJson(this.imgTanhao.jsonobj);
			icon.Init();
			icon.setPosition(this.imgTanhao.getPosition());
			widget.addChild(icon);
			widget.warn = icon
		}
		widget.warn.visible = warn;
	},

	OnShow:function () {
		var list = this._ReposBtns();
		this.showType = this._RepanelType(this.showType, list);
		if ( this.showType == null ) {
			Mgr.tips.ShowNotice("没有开放功能");
			return;
		}
		this.ChangePanel(DuanzaoTypeEnum.EQUIP_UP);
		// warn
		this.UpdataWarn();
	},

	_RepanelType:function (showType,openTyps) {
		var type = null;
		if ( openTyps.length == 0 )
			return type;

		for ( var i = 0; i != openTyps.length; i++ ) {
			if ( openTyps[i] == showType ){
				type = showType;
				break;
			}
		}
		if ( type == null ) {
			type = openTyps[0];
		}
		return type;
	},

	/**按钮重排*/
	_ReposBtns:function(){
		var buttons = [];
		var types = [];
		for (var i = 0; i < this._btnArr.length; i++ ) {
			var type = this._btnArr[i].type;
			// 移除
			if ( this._btnArr[i].btn.parent )
				this._btnArr[i].btn.removeFromParent();

			var main = BtnGroupUtil.M_FORGR;
			var sub;
			if ( type == DuanzaoTypeEnum.EQUIP_UP )
				sub = BtnGroupUtil.FORGR_UP;
			else if ( type == DuanzaoTypeEnum.EQUIP_INLAY )
				sub = BtnGroupUtil.FORGR_INLAY;
			else if ( type == DuanzaoTypeEnum.EQUIP_COMPOSE )
				sub = BtnGroupUtil.FORGR_COMPOSE;
			else if ( type == DuanzaoTypeEnum.EQUIP_MELTING )
				sub = BtnGroupUtil.FORGR_MELT;
			else if ( type == DuanzaoTypeEnum.EQUIP_REFINE )
				sub = BtnGroupUtil.FORGR_REFINE;
			else if ( type == DuanzaoTypeEnum.EQUIP_SUIT )
				sub = BtnGroupUtil.FORGR_SUIT;

			if (BtnGroupUtil.IsFunctionOpen(main, sub)) {
				buttons.push(this._btnArr[i].btn);
				types.push(this._btnArr[i].type);
			}
		}
		for (var i = 0; i < buttons.length; i++ ) {
			buttons[i].setPosition(this._btnPosArr[i]);
			this.addChild(buttons[i]);
		}
		return types;
	},
} );
DuanzaoPanelExt.PanelName = "DuanzaoPanelExt";
PanelClassDic["DuanzaoPanelExt"] = DuanzaoPanelExt;
