var HechengMainExt = HechengMain.extend ( {
	_className:"HechengMainExt",

	// list
	_listView : null,
	curSelectItem : null,
	_innerContainer : null,
	_lastPositionMap : null,

	// 遮罩
	_clipper: null,

	_btnArr : null,

	// effect
	effects:null,

	ctor:function(){
		this._super();
		this._btnArr = [];
		this._lastPositionMap = {};
		this.effects = [];
	},

	Init:function() {
		var self = this;
		HechengMain.prototype.Init.call( this );

		this._InitParam();

		this.btnHpGem.addClickEventListener(function (event){
			self._AddSubButtons( this, StoneAttributeEnum.HP );
		});
		this.btnFangyuGem.addClickEventListener(function (event){
			self._AddSubButtons( this, StoneAttributeEnum.DEFENSE );
		});
		this.btnGongjiGem.addClickEventListener(function (event){
			self._AddSubButtons( this, StoneAttributeEnum.ATTACK );
		});

		this.btnShengji.addClickEventListener(function (event){   //  一键合成
			if ( !self.gridItem.data) {
				Mgr.tips.ShowNotice("请选者一个类型");
				return;
			}
			var list = DuanzaoUtil.GetEnableComposeStone( self.curSelectItem.type, self.curSelectItem.level );
			if ( list.length <= 0 ) {
				Mgr.tips.ShowNotice("没有可合成的宝石");
				return;
			}

			//获取对应的材料
			var metrialList = [];
			for ( var i = 0; i != list.length; i++ ) {
				var aList = DuanzaoUtil.GetStoneByType( EnumItemType.GEM, list[i].q_location );
				for ( var j = 0; j != aList.length; j++ ) {
					if ( list[i].q_rank == (aList[j].q_rank + 1) ) {
						metrialList.push(aList[j]);
						break;
					}
				}
			}

            var handleType = 0;  // 0普通合成(后端自己检测) 1装备合成装备(手动放置)
            var stonelist = Mgr.backpack.GetItemsByMid( self.gridItem1.data.q_id, true);
            var count = Mgr.backpack.GetItemNumber( self.gridItem1.data.q_id, true );
            for(var j = 0; j != stonelist.length; j++){
                if(stonelist[j].itemBind == 1 &&((count - stonelist[j].itemNum) + stonelist[j].itemNum%3) >= 3
					&&(count - stonelist[j].itemNum)!=0&&stonelist[j].itemNum%3!=0){
                    var str = "当前合成的宝石中有绑定宝石，合成新的宝石也将绑定，是否进行合成？";
                    AlertExt.Show(str,TipsEnum.BUTTON_SURE_AND_FALSE,{
                        _onFunc:function(){
                            self.AllCompose(handleType, list, metrialList);
                        },
                        _offFunc:function(){
                        }
                    });
                    break;
                }
                else if(stonelist.length == 1||
					(stonelist[j].itemBind == 1 && (((count - stonelist[j].itemNum) + stonelist[j].itemNum%3) < 3 || stonelist[j].itemNum%3 ==0))){
                    self.AllCompose(handleType, list, metrialList);
                    break;
                }
            }
		});
		this.btnXiangqian.addClickEventListener(function (event){  // 合成
			if ( !self.gridItem.data ) {
				Mgr.tips.ShowNotice("请选则要合成的宝石");
				return;
			}

			if ( !DuanzaoUtil.IsEnableHecheng(self.curSelectItem.type, self.curSelectItem.level) ) {
				Mgr.tips.ShowNotice("宝石合成材料不足");
				return;
			}

			var handleType = 0;  // 0普通合成(后端自己检测) 1装备合成装备(手动放置)
			var itemModel = self.gridItem.data.q_id;
            var stonelist = Mgr.backpack.GetItemsByMid( self.gridItem1.data.q_id, true);
            for(var j = 0; j != stonelist.length; j++){
                if(stonelist[j].itemBind == 1 &&stonelist.length == 2 && stonelist[j].itemNum < 3){
                    var str = "当前合成的宝石中有绑定宝石，合成新的宝石也将绑定，是否进行合成？";
                    AlertExt.Show(str,TipsEnum.BUTTON_SURE_AND_FALSE,{
                        _onFunc:function(){
                            self.Compose(handleType, itemModel);
                        },
                        _offFunc:function(){
                        }
                    });
					break;
                }
                else if(stonelist.length == 1||(stonelist[j].itemBind == 1 && stonelist.length == 2 && stonelist[j].itemNum >= 3)){
                    self.Compose(handleType, itemModel);
                    break;
				}
            }
		});

		this.AddEffect();
	},

	AllCompose:function(handleType, list, metrialList){
        for ( var i = 0; i!= list.length; i++ ) {
            var itemModel = list[i].q_id;
            if ( !metrialList[i] ) {
                cc.log("合成装备id：" + itemModel + " 的材料获取失败 ");
                return;
            }

            var count = 0;
            var bagList = Mgr.backpack.GetItemsByMid( metrialList[i].q_id, true);
            for ( var j = 0; j != bagList.length; j++ ) {
                count += bagList[j].itemNum;
            }

            var num = count / 3;
            var itemIdList = [bagList[0].itemId];

            // 隔0.3秒发一次
            (function(handleType, itemModel, num, itemIdList){
                TimerUtil.SetTimeout( Mgr.refining, Mgr.refining.SendReqComposeGodEquipMessage, 300, handleType, itemModel, num, itemIdList);
            })(handleType, itemModel, num, itemIdList);
        }
	},

	Compose:function(handleType, itemModel){
        var num = 1;
        var itemIdList = [];
        var list = Mgr.backpack.GetItemsByMid( this.gridItem1.data.q_id, true);
        if (list.length > 0 )
            itemIdList.push( list[0].itemId );
        Mgr.refining.SendReqComposeGodEquipMessage( handleType, itemModel, num, itemIdList );
	},

	AddEffect:function () {
		// effect
		var url = "other/duanzhao/image/effect/compose/star.png";
		var effect_star = ParticleEffect.Create(this.imgEffect,url,1,300,90,120);
		effect_star.SetRotate(1.0 , 30);
		effect_star.SetFade(0.2,0.6);
		effect_star.SetRadiusRandomShow();
		effect_star.Play();

		url = "other/duanzhao/image/effect/compose/fog.png";
		var effect_flog = ParticleEffect.Create(this.imgEffect1,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(30,0);
		effect_flog.Play();

		effect_flog = ParticleEffect.Create(this.imgEffect1,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(160,0);
		effect_flog.Play();
	},

	AddEffect:function () {
		// effect
		var url = "other/duanzhao/image/effect/compose/star.png";
		var effect_star = ParticleEffect.Create(this.imgEffect,url,1,300,90,120);
		effect_star.SetRotate(1.0 , 30);
		effect_star.SetFade(0.2,0.6);
		effect_star.SetRadiusRandomShow();
		effect_star.Play();
		this.effects.push(effect_star);

		url = "other/duanzhao/image/effect/compose/fog.png";
		var effect_flog = ParticleEffect.Create(this.imgEffect1,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(30,0);
		effect_flog.Play();
		this.effects.push(effect_flog);

		effect_flog = ParticleEffect.Create(this.imgEffect1,url,4,1500,0,180);
		effect_flog.SetFade(0.3,0.7);
		effect_flog.SetMove(1);
		effect_flog.SetRadiusRandomShow();
		effect_flog.SetAngle(160,0);
		effect_flog.Play();
		this.effects.push(effect_flog);
	},

	StopEffect:function () {
		for ( var i = 0; i != this.effects.length; i++ ) {
			this.effects[i].Dispose();
		}
		this.effects = [];
	},

	_InitPosition:function()
	{
		this.x = 0;
		this.y = 0;
	},

	_InitParam:function() {
		this._InitPosition();

		this.imgtanhao.visible = false;
		this.sbtn1.setTouchEnabled(false);
		this.sbtn2.setTouchEnabled(false);
		this.sbtn3.setTouchEnabled(false);

		this._AddShade();
		this._SetLabelLink();
		this._SetButtonBindType();
		this._CreateListView();
	},

	_AddShade:function () {
		var shape = new cc.DrawNode();
		var rectangle = [];
		rectangle[0] = cc.p(0, 0);
		rectangle[1] = cc.p(this.imgShade.width, 0);
		rectangle[2] = cc.p(this.imgShade.width, this.imgShade.height);
		rectangle[3] = cc.p(0, this.imgShade.height);
		var green = cc.color(0, 255, 0, 255);
		shape.drawPolygon(rectangle,4, green, 0, green);
		shape.setPosition(0,0);

		var clipper = new cc.ClippingNode();
		clipper.stencil = shape;
		clipper.setPosition(0,0);
		this.imgShade.addChild( clipper );

		var pos = this.btnHpGem.getPosition();
		this.btnHpGem.retain();
		this.btnHpGem.removeFromParent();
		this.btnHpGem.setPosition(pos);
		clipper.addChild(this.btnHpGem);

		pos = this.btnFangyuGem.getPosition();
		this.btnFangyuGem.retain();
		this.btnFangyuGem.removeFromParent();
		this.btnFangyuGem.setPosition(pos);
		clipper.addChild(this.btnFangyuGem);

		pos = this.btnGongjiGem.getPosition();
		this.btnGongjiGem.retain();
		this.btnGongjiGem.removeFromParent();
		this.btnGongjiGem.setPosition(pos);
		clipper.addChild(this.btnGongjiGem);
		this._clipper = clipper;
	},

	_SetButtonBindType:function () {
		this._btnArr = [
			{ obj:this.btnHpGem, type:StoneAttributeEnum.HP },
			{ obj:this.btnFangyuGem, type:StoneAttributeEnum.DEFENSE },
			{ obj:this.btnGongjiGem, type:StoneAttributeEnum.ATTACK }
		]
	},

	// label链接
	_SetLabelLink:function () {
		this.labCue1.setTouchEnabled(true);
		this.labCue1.addTouchEventListener(function(sender,type)
		{
			if ( type == ccui.Widget.TOUCH_BEGAN )
			{
				sender.setScale(1.01);
			}
			else if ( type == ccui.Widget.TOUCH_ENDED )
			{
				sender.setScale(1.0);
				Mgr.uiMgr.ShowPanelByType(QianghuaMetrialGetRouteExt.PanelName);
			}
			else if ( type == ccui.Widget.TOUCH_CANCELED )
			{
				sender.setScale(1.0);
			}
		});
	},

	_CreateListView:function () {
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.btnHpGem.width, 200));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setItemsMargin(4);
		list.setAnchorPoint(0, 1);
		list.setScrollBarEnabled(false)
		list.addEventListener(this._SelectedItemEvent);
		list.retain();
		this._innerContainer = list.getInnerContainer();
		this._listView = list;
		this._listView.type = null;
		this._listView.button = null;

		for (var i = 2; i <= Mgr.refining._maxStoneLv; i++) {
			var item = new HechengFrameExt();
			item.LoadPanel();
			this._AddItem(item);
		}
	},

	_SetCheckBoxState:function (type, boo) {
		this.sbtn1.SetButtonState( "uncheck" );
		this.sbtn2.SetButtonState( "uncheck" );
		this.sbtn3.SetButtonState( "uncheck" );
		var state = boo ? "check" : "uncheck";
		switch (type)
		{
			case StoneAttributeEnum.HP:
				this.sbtn1.SetButtonState( state );
				break;
			case StoneAttributeEnum.DEFENSE:
				this.sbtn2.SetButtonState( state );
				break;
			case StoneAttributeEnum.ATTACK:
				this.sbtn3.SetButtonState( state );
				break;
		}
	},

	_AddItem:function( item ){
		item.setTouchEnabled(true);
		this._listView.pushBackCustomItem(item);
	},

	SetData:function () {
		if ( !this.curSelectItem ) {
            var list = DuanzaoUtil.GetEnableComposeStone();
            if(list.length > 0){
                var item = list[0];
                this.SelectCanCompose(item);
			}
			else
                this._AddSubButtons(this.btnHpGem, StoneAttributeEnum.HP);
		}
		else {
			// this.curSelectItem.SetSelect(true);
			// this._SetHecheng(this.curSelectItem.type, this.curSelectItem.level);
            this.UpdataSelect();
		}
		this.UpdataWarn();
	},

    UpdataSelect:function(){
        var composelist = DuanzaoUtil.GetEnableComposeStone();
        if(composelist.length > 0){
            var item = composelist[0];
            if(this.curSelectItem.type == item.q_location){
                if (this.curSelectItem) {
                    this.curSelectItem.SetSelect(false);
                    this.curSelectItem = null;
                }
                this._AutoSelect(item.q_location);
            }else{
                this.SelectCanCompose(item);
            }
        }
    },

    SelectCanCompose:function(item){
        switch(item.q_location){
            case StoneAttributeEnum.HP:
                this._AddSubButtons(this.btnHpGem, StoneAttributeEnum.HP);
                // this._AutoSelect(StoneAttributeEnum.HP, item.q_rank);
                break;
            case StoneAttributeEnum.ATTACK:
                this._AddSubButtons(this.btnFangyuGem, StoneAttributeEnum.ATTACK);
                // this._AutoSelect(StoneAttributeEnum.ATTACK, item.q_rank);
                break;
            case StoneAttributeEnum.DEFENSE:
                this._AddSubButtons(this.btnGongjiGem, StoneAttributeEnum.DEFENSE);
                // this._AutoSelect(StoneAttributeEnum.DEFENSE, item.q_rank);
                break;
            default:
                break;
        }
    },

	_AddSubButtons:function ( button, type ) {
		if ( this._listView ) {
			var find = false;
			if ( this._listView.getParent() ) {
				//位置恢复
				for (var i = 0; i != this._btnArr.length; i++) {
					if (this._btnArr[i].obj == this._listView.button) {
						find = true;
						continue;
					}
					else if (!find)
						continue;

					this._btnArr[i].obj.y = this._btnArr[i].obj.y + this._listView.height;
				}

				this._lastPositionMap[this._listView.type] = this._innerContainer.getPosition();
				
				var sample = (button == this._listView.button);
				//移除
				this._listView.removeFromParent();

				// checkbox state
				this._SetCheckBoxState(this._listView.type, false);

				if (sample)
					return;
			}

			//重置链表信息
			this._listView.x = button.x;
			this._listView.y = button.y - 5;
			this._listView.type = type;
			this._listView.button = button;
			this._clipper.addChild(this._listView);
			if ( !this._lastPositionMap[type] ) {
				this._listView.jumpToTop();
			}
			else {
				this._innerContainer.setPosition( this._lastPositionMap[type] );
			}

			var items = this._listView.getItems();
			for ( var i = 0; i != items.length; i++ ) {
				items[i].InitItem();
				items[i].SetData(type, (i+2));
			}

			//位置变化
			find = false;
			for ( var i = 0; i != this._btnArr.length; i++ ) {
				if ( this._btnArr[i].obj == button ) {
					find = true;
					continue;
				}
				else if ( !find )
					continue;

				this._btnArr[i].obj.y = this._btnArr[i].obj.y - this._listView.height;
			}
			// checkbox state
			this._SetCheckBoxState(type, true);

			// 选择项
			if (this.curSelectItem) {
				this.curSelectItem.SetSelect(false);
				this.curSelectItem = null;
			}
			this._AutoSelect(type);
		}
	},

	_AutoSelect:function (type) {
		//默认列表第一个
        var level = 2;

		//优选可合成项
		var list = DuanzaoUtil.GetEnableComposeStone();
		for ( var i = 0; i != list.length; i++ ) {
			if ( list[i].q_location == type ) {
				level = list[i].q_rank;
				break;
			}
		}

		//找到对应 list item
		var items = this._listView.getItems();
		for ( var i = 0; i != items.length; i++ ) {
			if ( items[i].level == level ) {
				items[i].SetSelect(true);
				this.curSelectItem = items[i];
				this.SetListViewPos(this.curSelectItem);
				this._SetHecheng(items[i].type, items[i].level);
				break;
			}
		}
	},

	// 使用前提： this._innerContainer.height 必须 >= this._listView.height;
	SetListViewPos:function ( item ) {
		var offy = this._listView.height - Math.abs(item.getPosition().y + item.height);
		if ( offy > 0)
				offy = 0;
		this._innerContainer.setPositionY(offy);
	},

	_SelectedItemEvent: function (sender, type) {
		switch (type) {
			case ccui.ListView.ON_SELECTED_ITEM_END:
				var parent = sender.parent.parent.parent;
				if ( parent.curSelectItem != null) {
					parent.curSelectItem.SetSelect(false);
					parent.curSelectItem = null;
				}

				var idx = sender.getCurSelectedIndex();
				var itemSelect = sender.getItem(idx);
				itemSelect.SetSelect(true);
				parent._SetHecheng( itemSelect.type, itemSelect.level );
				parent.curSelectItem = itemSelect;
				break;
			default:
				break;
		}
	},

	//基础逻辑
	_SetHecheng:function ( stoneType, lv ) {
		var MetrialStoneC = null;
		var stoneC = null;
		var list = DuanzaoUtil.GetStoneByType( EnumItemType.GEM, stoneType );
		for ( var i = 0; i != list.length; i++ ) {
			if ( list[i].q_rank == (lv - 1) )  // lv 最小2级开始
				MetrialStoneC = list[i];
			else if ( list[i].q_rank == lv )
				stoneC = list[i];
		}
		var stonelist = Mgr.backpack.GetItemsByMid(MetrialStoneC.q_id, true);
		var bind = false;
		for(var j = 0; j != stonelist.length; j++){
			if(stonelist[j].itemBind == 1)
				bind = true;
		}

		this._SetMatrialGrid( this.gridItem1, MetrialStoneC, bind);
		this._SetHcGrid( this.gridItem, stoneC , bind);
	},

	_SetMatrialGrid:function ( grid, stoneC, bind) {
		grid.Clean();
		if ( stoneC ) {
            if(bind)
                GridUtil.AddLock(grid);
			// icon
			// var icon = ItemUtil.GetItemIcon(stoneC.q_id, ResUrl.ITEM_SIZE_60)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            var coinInfo = {};
            coinInfo.itemModelId = stoneC.q_id;
            // coinInfo.itemNum = price;
            // coinInfo.itemBind = itemInfo.q_bind;
            GridUtil.SetItemGrid(grid,coinInfo, null, null, null, false);
			grid.data = stoneC;

			// lv
			grid.reorderChild(this.labLv21, 3);
			var str = (stoneC.q_rank).toString() + "级";
			this.labLv21.SetString(str);

			// number
			grid.reorderChild(this.labNumber, 3);
			grid.reorderChild(this.labNumber1, 3);
			var count = Mgr.backpack.GetItemNumber( stoneC.q_id, true );
			this.labNumber.SetString("/3");

			this.labNumber1.SetString(count);
			if (  count < 3 )
				this.labNumber1.SetColor( "0xEE0000" );
			else
				this.labNumber1.SetColor( "0xffffff" );

			//attr
			var attrV = DuanzaoUtil.GetAttributeV( stoneC.q_id, stoneC.q_rank );
			str = String(attrV.str) + "+" + String( attrV.value );
			this.labGgongji1.SetString(str);
		}
	},

	_SetHcGrid:function ( grid, stoneC, bind) {
		grid.Clean();
		if ( stoneC ) {
            if(bind)
            	GridUtil.AddLock(grid);
			// icon
			// var icon = ItemUtil.GetItemIcon(stoneC.q_id, ResUrl.ITEM_SIZE_60)
			// icon.x = (grid.uiWidth - icon.width) / 2;
			// icon.y = (grid.uiHeight - icon.height) / 2;
			// grid.SetGridIcon(icon);
            var coinInfo = {};
            coinInfo.itemModelId = stoneC.q_id;
            // coinInfo.itemNum = price;
            // coinInfo.itemBind = itemInfo.q_bind;
            GridUtil.SetItemGrid(grid,coinInfo, null, null, null, false);
			grid.data = stoneC;

			// lv
			var str = (stoneC.q_rank).toString() + "级";
			this.labLv2.SetString(str);
			grid.reorderChild(this.labLv2, 3);

			//attr
			var attrV = DuanzaoUtil.GetAttributeV( stoneC.q_id, stoneC.q_rank );
			str = attrV.str + "+" + String( attrV.value );
			this.labGgongji.SetString(str);
		}
	},

	UpdataWarn:function () {
		// 类型warn
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			var button = this._btnArr[i].obj;
			if ( !button.warn ) {
				var icon = new MUIImage();
				icon.ParseJson(this.imgtanhao.jsonobj);
				icon.Init();
				icon.setPosition(this.imgtanhao.getPosition());
				button.addChild(icon);
				button.warn = icon;
			}
			var listx = DuanzaoUtil.GetEnableComposeStone( this._btnArr[i].type );
			button.warn.visible = listx.length > 0;
		}

		// 等级warn
		if ( this._listView ) {
			var list = this._listView.getItems();
			for (var i = 0; i != list.length; i++) {
				var listX = DuanzaoUtil.GetEnableComposeStone(list[i].type, list[i].level);
				list[i].imgTanhao.visible = listX.length > 0;
			}
		}
	},

	OnShow:function () {
		this.SetData();
	},
} );
HechengMainExt.PanelName = "HechengMainExt";
PanelClassDic["HechengMainExt"] = HechengMainExt;
