var BianqiangMainExt = BianqiangMain.extend ( {
	_className:"BianqiangMainExt",

	_listView:null,
	_buttons:null,

	ctor:function(){
		this._super();
		this._buttons = {};
	},

	Init:function() {
		var self = this;
		BianqiangMain.prototype.Init.call(this);

		this.InitParam();

		this.btnClose.addClickEventListener(function (event) {
			Mgr.uiMgr.HidePanel(self);
		});
	},

	InitParam:function () {
		this.btnCue.visible = false;
		this._CreateListView();
	},

	_CreateListView:function () {
		// listView
		var list = new ccui.ListView();
		list.setDirection(ccui.ScrollView.DIR_VERTICAL);
		list.setGravity(ccui.ListView.GRAVITY_CENTER_HORIZONTAL);
		list.setContentSize(cc.size(this.imgBg.width, this.imgBg.height));
		list.setTouchEnabled(true);
		list.setBounceEnabled(true);
		list.setScrollBarEnabled(false)
		list.setItemsMargin(2);
		//list.setAnchorPoint(0, 0);
		//list.setPosition(0,0);
		//list.addEventListener(this._SelectedItemEvent);
		this.imgBg.addChild(list);
		this._listView = list;
	},

	OnShow:function () {
		this.LoadList();
	},

	LoadList:function () {
		this._listView.removeAllItems();
		var types = Mgr.strong.GetTypes();
		for ( var i = 0; i != types.length; i++ ) {
			this.Contain(types[i]);
		}
	},

	Contain:function (type) {
		var button = this._buttons[type];
		if ( !button ) {
			button = new MUIButton();
			button.ParseJson(this.btnCue.jsonobj);
			button.Init();
			button.retain();
			button.type = type;
			button.setTitleText( this.GetNameByType(type) );
			button.addClickEventListener(this._CallBackFunc);
			this._buttons[type] = button;
		}
		if ( !button.getParent() )
			this._listView.pushBackCustomItem(button);
	},

	Except:function (type) {
		var button = this._buttons[type];
		var items = this._listView.getItems();
		var index = items.indexOf(button);
		if(index > -1)
			this._listView.removeChild(button);

	},

	_CallBackFunc:function (event) {
		switch( event.type ){
			case ElseStrongEnum.ELSE_BAOQI:
				Mgr.uiMgr.ShowPanelByType(ShuTongPanelExt.PanelName).ChangePanel(EnumResline.BAOQI);
				break;
			case ElseStrongEnum.ELSE_CHENGHAO:
				EngineMgr.uiMgr.ShowPanelByType(ChengHaoPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
				break;
			case ElseStrongEnum.ELSE_COMPOSE:
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_COMPOSE);
				break;
			case ElseStrongEnum.ELSE_GUANGWU:
				Mgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName).ChangePage(EnumResline.GUANGWU);
				break;
			case ElseStrongEnum.ELSE_GUILDSKILL:
				Mgr.uiMgr.ShowPanelByType(GuildPanelExt.PanelName).ChangePanel(GuildEnum.PANEL_SKILL);
				break;
			case ElseStrongEnum.ELSE_INLAY:
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_INLAY);
				break;
			case ElseStrongEnum.ELSE_MELTING:
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_MELTING);
				break;
			case ElseStrongEnum.ELSE_REFINE:
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_REFINE);
				break;
			case ElseStrongEnum.ELSE_RIDE:
				Mgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName).ChangePage(EnumResline.HORSE);
				break;
			case ElseStrongEnum.ELSE_SHIZHUANG:
                Mgr.fasion.SendReqFashionPanelMessage();
				break;
			case ElseStrongEnum.ELSE_SHUTONG:
				Mgr.uiMgr.ShowPanelByType(ShuTongPanelExt.PanelName).ChangePanel(EnumResline.SHUTONG);
				break;
			case ElseStrongEnum.ELSE_SKILL:
				Mgr.uiMgr.ShowPanelByType(SkillPanelExt.PanelName).ChangePanel(SkillPanelType.PANEL_STATIC );;
				break;
			case ElseStrongEnum.ELSE_SUIT:
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_SUIT);
				break;
			case ElseStrongEnum.ELSE_TAIJI:
				EngineMgr.uiMgr.ShowPanelByType(TaijiPanelExt.PanelName);
				Mgr.gossip.taijiPanel.ShowType(EnumGrossipType.TYPE_DAY);
				break;
			case ElseStrongEnum.ELSE_TOUXIAN:
				EngineMgr.uiMgr.ShowPanelByType(TouXianPanelExt.PanelName,UIMgr.PANEL_LAYER_TOP);
				break;
			case ElseStrongEnum.ELSE_TUJIAN:
				EngineMgr.uiMgr.ShowPanelByType( TujianPanelExt.PanelName );
				break;
			case ElseStrongEnum.ELSE_UP:
				Mgr.uiMgr.ShowPanelByType(DuanzaoPanelExt.PanelName).ChangePanel(DuanzaoTypeEnum.EQUIP_UP);
				break;
			case ElseStrongEnum.ELSE_DRAGON:
				Mgr.uiMgr.ShowPanelByType(PlayerPanelExt.PanelName).ChangePage(EnumResline.DRAGON);
				break;
			case ElseStrongEnum.ELSE_YIRONG:
				EngineMgr.uiMgr.ShowPanelByType(YiRongPanelExt.PanelName);
				break;
			case ElseStrongEnum.ELSE_ZHANJIA:
				EngineMgr.uiMgr.ShowHidePanelByType( PlayerPanelExt.PanelName );
				var panel = Mgr.uiMgr.GetPanelByType(PlayerPanelExt.PanelName);
				if(panel)
				{
					panel.ChangePage(0);
				}
				break;
			default:
				break;
		}
		Mgr.uiMgr.HidePanelByType(BianqiangMainExt.PanelName);
	},

	GetNameByType:function (type) {
		var name = "未知名称"
		if ( type == ElseStrongEnum.ELSE_BAOQI )
			name = "宝骑进阶"
		else if ( type == ElseStrongEnum.ELSE_CHENGHAO )
			name = "角色称号"
		else if ( type == ElseStrongEnum.ELSE_COMPOSE )
			name = "宝石合成"
		else if ( type == ElseStrongEnum.ELSE_GUANGWU )
			name = "光武进阶"
		else if ( type == ElseStrongEnum.ELSE_GUILDSKILL )
			name = "帮会技能"
		else if ( type == ElseStrongEnum.ELSE_INLAY )
			name = "宝石镶嵌"
		else if ( type == ElseStrongEnum.ELSE_MELTING )
			name = "装备熔炼"
		else if ( type == ElseStrongEnum.ELSE_REFINE )
			name = "装备精炼"
		else if ( type == ElseStrongEnum.ELSE_RIDE )
			name = "坐骑进阶"
		else if ( type == ElseStrongEnum.ELSE_SHIZHUANG )
			name = "角色时装"
		else if ( type == ElseStrongEnum.ELSE_SHUTONG )
			name = "书童进阶"
		else if ( type == ElseStrongEnum.ELSE_SKILL )
			name = "被动技能"
		else if ( type == ElseStrongEnum.ELSE_SUIT )
			name = "套装打造"
		else if ( type == ElseStrongEnum.ELSE_TAIJI )
			name = "太极阵"
		else if ( type == ElseStrongEnum.ELSE_TOUXIAN )
			name = "角色头衔"
		else if ( type == ElseStrongEnum.ELSE_TUJIAN )
			name = "怪物图鉴"
		else if ( type == ElseStrongEnum.ELSE_UP )
			name = "装备强化"
		else if ( type == ElseStrongEnum.ELSE_DRAGON )
			name = "法器进阶"
		else if ( type == ElseStrongEnum.ELSE_YIRONG )
			name = "角色易容"
		else if ( type == ElseStrongEnum.ELSE_ZHANJIA )
			name = "战甲淬炼"
		return name;
	},
} );
BianqiangMainExt.PanelName = "BianqiangMainExt";
PanelClassDic["BianqiangMainExt"] = BianqiangMainExt;

var StrongModMgr = StrongModMgr || cc.Class.extend({

		_typeList:null,
		_openTypeList:null,   // 自动弹出类型

		ctor:function () {
			this._typeList = [];
			this._openTypeList = [ElseStrongEnum.ELSE_RIDE, ElseStrongEnum.ELSE_GUANGWU, ElseStrongEnum.ELSE_SHUTONG,
				ElseStrongEnum.ELSE_BAOQI, ElseStrongEnum.ELSE_DRAGON, ElseStrongEnum.ELSE_UP];
		},

		Contain:function (type) {
			// 判断是否开启
			if ( this.CheckFuncOpen(type) ) {
				if (!this.IsIner(type)) {
					this._typeList.push(type);
					this.SortButtons();
					var initMark = Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).GetInitMark();
					if ( initMark == false ) { // 初始登录标记
						if( Mgr.uiMgr.IsPanelShowByName(NewFuncCueExt.PanelName) || Mgr.uiMgr.IsPanelShowByName(NewFuncCue1Ext.PanelName))	//新功能开启展示出来的不弹出
							return;
						// 指定自动弹出面板类型
						var list = Mgr.strong.GetOpenTypes();
						for (var i = 0; i != list.length; i++) {
							if (type == list[i]) {
								var panel = Mgr.uiMgr.ShowPanelByType(BianqiangMainExt.PanelName);
								var winSize = cc.director.getWinSize();
								panel.x = winSize.width - panel.width * 2.5;
								panel.y = 200;
								break;
							}
						}
					}
				}
			}
		},

		Except:function (type) {
			var index = this._typeList.indexOf(type);
			if(index > -1) {
				this._typeList.splice(index, 1);
				this.SortButtons();
			}
		},

		SortButtons:function () {
			// 快捷图标是否显示
			var _visible = this._typeList.length > 0;
			Mgr.uiMgr.GetPanelByType(ShortcutPanelExt.PanelName).ShowAndHideStrong(_visible);
			// 面板更新
			var panel = Mgr.uiMgr.GetPanelByType(BianqiangMainExt.PanelName);
			if ( panel && panel.visible ) {
				panel.LoadList();
			}
			if( !_visible )
				Mgr.uiMgr.HidePanelByType(BianqiangMainExt.PanelName);
		},

		IsIner:function (type) {
			var len = this._typeList.length;
			for ( var i = 0; i != len; i++ ) {
				var _type = this._typeList[i];
				if ( _type == type )
					return true;
			}
			return false;
		},

		CheckFuncOpen:function (type) {
			var main, sub;
			switch( type ) {
				case ElseStrongEnum.ELSE_BAOQI:
					main = BtnGroupUtil.M_JINJIE;
					sub = BtnGroupUtil.JINJIE_BAOQI;
					break;
				case ElseStrongEnum.ELSE_CHENGHAO:
					main = BtnGroupUtil.M_ROLE;
					sub = BtnGroupUtil.ROLE_TITLE;
					break;
				case ElseStrongEnum.ELSE_COMPOSE:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_COMPOSE;
					break;
				case ElseStrongEnum.ELSE_GUANGWU:
					main = BtnGroupUtil.M_JINJIE;
					sub = BtnGroupUtil.JINJIE_GUANGWU;
					break;
				case ElseStrongEnum.ELSE_GUILDSKILL:
					main = BtnGroupUtil.M_SHORTCUT;
					sub = BtnGroupUtil.SHORT_GUILD;
					break;
				case ElseStrongEnum.ELSE_INLAY:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_INLAY;
					break;
				case ElseStrongEnum.ELSE_MELTING:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_MELT;
					break;
				case ElseStrongEnum.ELSE_REFINE:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_REFINE;
					break;
				case ElseStrongEnum.ELSE_RIDE:
					main = BtnGroupUtil.M_JINJIE;
					sub = BtnGroupUtil.JINJIE_HOURSE;
					break;
				case ElseStrongEnum.ELSE_SHIZHUANG:
					main = BtnGroupUtil.M_SHORTCUT;
					sub = BtnGroupUtil.SHORT_FASHION;
					break;
				case ElseStrongEnum.ELSE_SHUTONG:
					main = BtnGroupUtil.M_JINJIE;
					sub = BtnGroupUtil.JINJIE_SHUTONG;
					break;
				case ElseStrongEnum.ELSE_SKILL:
					main = BtnGroupUtil.M_SHORTCUT;
					sub = BtnGroupUtil.SHORT_SKILL;
					break;
				case ElseStrongEnum.ELSE_SUIT:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_SUIT;
					break;
				case ElseStrongEnum.ELSE_TAIJI:
					main = BtnGroupUtil.M_TAIJI;
					sub = BtnGroupUtil.TAIJI_TAIJI;
					break;
				case ElseStrongEnum.ELSE_TOUXIAN:
					main = BtnGroupUtil.M_ROLE;
					sub = BtnGroupUtil.ROLE_HONOR;
					break;
				case ElseStrongEnum.ELSE_TUJIAN:
					main = BtnGroupUtil.M_SHORTCUT;
					sub = BtnGroupUtil.SHORT_POKEDEX;
					break;
				case ElseStrongEnum.ELSE_UP:
					main = BtnGroupUtil.M_FORGR;
					sub = BtnGroupUtil.FORGR_UP;
					break;
				case ElseStrongEnum.ELSE_DRAGON:
					main = BtnGroupUtil.M_JINJIE;
					sub = BtnGroupUtil.JINJIE_FAQI;
					break;
				case ElseStrongEnum.ELSE_YIRONG:
					main = BtnGroupUtil.M_SHORTCUT;
					sub = BtnGroupUtil.SHORT_DISGUISE;
					break;
				case ElseStrongEnum.ELSE_ZHANJIA:
					main = BtnGroupUtil.M_ROLE;
					sub = BtnGroupUtil.ROLE_ARMOR;
					break;
				default:
					break;
			}
			if (BtnGroupUtil.IsFunctionOpen(main, sub)) {
				return true;
			}
			return false;
		},

		GetTypes:function () {
			return this._typeList;
		},
		GetOpenTypes:function () {
			return this._openTypeList;
		},
	});
