var GemModMgr = GemModMgr || cc.Class.extend({
	// 所有宝石
	_allStones:null,

	// 人物镶嵌宝石
	_inlayStones:null,
	_inlayStonesHash:null,

	ctor:function() {
		this._allStones = {};
		this._inlayStones = {};
		this._inlayStonesHash = new HashMap();
	},

	RecvResSendGemAllInfoToClientMessage:function(msg) {
		cc.log(" RecvResSendGemAllInfoToClientMessage!!! ");
		this._allStones = {};
		for ( var i = 0; i != msg.gemInfos.length; i++ ) {
			var data = msg.gemInfos[i];
			this._allStones[data.sysType] = data;
		}
		this._RoleStones();
	},

	RecvResSendGemInfoToClientMessage:function(msg) {
		cc.log("---------------- ResSendGemInfoToClientMessage!!! ");
		this._allStones[msg.sysType] = msg.gemInfo;
		this._RoleStones();
	},

	SendReqGemInfoToGameMessage:function( type ) {
		cc.log(" ReqGemInfoToGameMessage!!! ");
		var msg = new ReqGemInfoToGameMessage();
		msg.sysType = type;
		Mgr.msgMgr.Send( msg );
	},

	SendReqGemChangeToGameMessage:function( operate, sysType, equipType, sid, pos ) {
		cc.log(" ReqGemChangeToGameMessage!!! ");
		var msg = new ReqGemChangeToGameMessage();
		msg.opType = operate;
		msg.sysType = sysType;
		msg.equipLocation = equipType;
        msg.gemId = sid;
		msg.gemLocation = pos;
		Mgr.msgMgr.Send( msg );
	},

	GetStonesByType:function (type) {
		return this._allStones[type];
	},

	_RoleStones:function () {
		var info = this.GetStonesByType(255); // 目前只用了人物宝石( 255  -1的补码 ) ，后续需要在做处理

		this._inlayStones = {};
		this._inlayStonesHash.Clear();

		if ( info ) {
			var stoneList = info.gemModelList;
			var equipTypes = info.equipLocationList;
			var stoneTypes = info.gemLocationList;   //此字段没什么用
		}
		else {
			var stoneList = [];
			var equipTypes = [];
			var stoneTypes = [];   //此字段没什么用
		}

		for ( var i = 0; i != stoneList.length; i++ ) {
			var gemInfo = stoneList[i];
			var equipType = equipTypes[i];

			var stoneC = Q_item.Get( gemInfo.gemModelId );
			// cc.assert(null != stoneC, "data is unexist in Q_item!  mid: " + mid);
			var stoneType = stoneC.q_location;

			// new
			var data = { equip_type:equipType, stone_type:stoneType, mid:gemInfo.gemModelId, stoneC:stoneC, isbind:gemInfo.isbind };
			// this._inlayStonesHash.Put(gemInfo.gemModelId, data);
            this.PutData(equipType, gemInfo.gemModelId, data);
			var list = this.GetInlayStones(equipTypes[i]);
			list.push( data );
		}
		var panel = Mgr.uiMgr.GetPanelByType(DuanzaoPanelExt.PanelName);
		if (panel) {
			var page = panel.panelMgr[DuanzaoTypeEnum.EQUIP_INLAY];
			if ( page )
				page.LayOutGrids();
		}
	},

	PutData:function(equipType, modeId, data){
        if(this._inlayStonesHash.ContainsKey(equipType)){
            this._inlayStonesHash.Get(equipType).Put(modeId, data);
        }
        else{
            var list = new HashMap();
            list.Put(modeId, data);
            this._inlayStonesHash.Put(equipType, list);
        }
	},

	GetInlayStones:function (equipType) {
		equipType = arguments.length > 0 ? parseInt(equipType):null;
		if ( equipType == null )
			return this._inlayStonesHash.Values();
		else {
			var list = this._inlayStones[equipType];
			if ( !list ) {
				list = [];
				this._inlayStones[equipType] = list;
			}
			return list;
		}
	},

	// 获取单个精确宝石
	GetInlayStone:function (equipType, stoneType) {
		var list = this.GetInlayStones(equipType);
		for ( var i = 0; i != list.length; i++ ) {
			if (list[i].stone_type == stoneType)
				return list[i];
		}
		return null;
	}
});