///////////////////////////////////////////////////////
// 此文件为工具自动生成消息定义文件，请勿做任何修改。//
///////////////////////////////////////////////////////

// 消息子结构
//DrawRecordPublicInfo public同步游戏服抽奖记录
//DrawRecordInfo 抽奖记录信息

// 请求消息
//167201,ReqLuckyDrawInfoClientToGame 抽奖面板信息
//167202,ReqLuckyDrawPerformClientToGame 请求开始抽奖

// 接收消息
//167101,ResLuckyDrawInfoGameToClient 返回抽奖面板信息
//167102,ResLuckyDrawResultGameToClient 抽奖结果
//167103,ResShenJiBoxLuckyDrawRecordToClinet 返回个人抽奖记录
//167104,ResLuckyDrawOwnNumsToClinet 告诉前端可用抽奖次数(充值抽奖等)
//167105,ResPrizePoolEnetrYanbaoNumToClinet 发送奖池元宝数量


var DrawRecordPublicInfo = cc.Class.extend({
	ctor:function(){
		this.drawTime = 0; // 抽奖时间(秒)
        this.serverKey = 0; // 抽奖玩家serverkey
        this.playerId = null; // 玩家Id
        this.playerName = null; // 玩家名字
        this.simpleItemInfo = null; // 简要道具信息
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.drawTime);
        _buf.WriteVarInt(this.serverKey);
        _buf.WriteLong(this.playerId);
        _buf.WriteString(this.playerName);
        _buf.WriteBean(this.simpleItemInfo);
	},
	
	reading:function( _buf ){
		this.drawTime = _buf.ReadVarInt();
        this.serverKey = _buf.ReadVarInt();
        this.playerId = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.simpleItemInfo = _buf.ReadBean(SimpleItemInfo);
	},
});
var DrawRecordInfo = cc.Class.extend({
	ctor:function(){
		this.drawTime = 0; // 抽奖时间(秒)
        this.serverKey = 0; // 抽奖玩家serverkey
        this.playerId = null; // 玩家Id
        this.playerName = null; // 玩家名字
        this.simpleItemInfo = null; // 简要道具信息
	},

	writing:function( _buf ){
		_buf.WriteVarInt(this.drawTime);
        _buf.WriteVarInt(this.serverKey);
        _buf.WriteLong(this.playerId);
        _buf.WriteString(this.playerName);
        _buf.WriteBean(this.simpleItemInfo);
	},
	
	reading:function( _buf ){
		this.drawTime = _buf.ReadVarInt();
        this.serverKey = _buf.ReadVarInt();
        this.playerId = _buf.ReadLong();
        this.playerName = _buf.ReadString();
        this.simpleItemInfo = _buf.ReadBean(SimpleItemInfo);
	},
});
////////////////////
// 返回抽奖面板信息 //
////////////////////
var ResLuckyDrawInfoGameToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.storeId = 0; // 对应的仓库ID,0表示没有
        this.luckyDrawType = 0; // 抽奖类型
        this.luckyDrawNums = 0; // 可抽奖次数
        this.blessValue = 0; // 祝福值(部分抽奖有)
        this.records = []; // 对应类型的奖励记录列表(全服记录) DrawRecordInfo
        this.playerRecords = []; // 个人抽奖记录 DrawRecordInfo
	},

	getId:function(){
		return 167101;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.storeId);
        _buf.WriteVarInt(this.luckyDrawType);
        _buf.WriteVarInt(this.luckyDrawNums);
        _buf.WriteVarInt(this.blessValue);
        _buf.WriteShort( this.records.length );
        for (var i = 0; i < this.records.length; i++) {
            _buf.WriteBean(this.records[i]);
        }
        _buf.WriteShort( this.playerRecords.length );
        for (var i = 0; i < this.playerRecords.length; i++) {
            _buf.WriteBean(this.playerRecords[i]);
        }
	},
	
	reading:function( _buf ){
        this.storeId = _buf.ReadVarInt();
        this.luckyDrawType = _buf.ReadVarInt();
        this.luckyDrawNums = _buf.ReadVarInt();
        this.blessValue = _buf.ReadVarInt();
        var records_length = _buf.ReadShort();
        for (var i = 0; i < records_length; i++) {
            this.records[i] = _buf.ReadBean(DrawRecordInfo);
        }
        var playerRecords_length = _buf.ReadShort();
        for (var i = 0; i < playerRecords_length; i++) {
            this.playerRecords[i] = _buf.ReadBean(DrawRecordInfo);
        }
	},

	action:function(){
		Mgr.luckydraw.RecvResLuckyDrawInfoGameToClientMessage(this);
	},

});
////////////////////
// 抽奖结果 //
////////////////////
var ResLuckyDrawResultGameToClientMessage = cc.Class.extend( {
	ctor:function(){
		this.items = []; // 奖励物品信息列表 TempItemInfo
        this.luckyDrawType = 0; // 抽奖类型
	},

	getId:function(){
		return 167102;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.items.length );
        for (var i = 0; i < this.items.length; i++) {
            _buf.WriteBean(this.items[i]);
        }
        _buf.WriteVarInt(this.luckyDrawType);
	},
	
	reading:function( _buf ){
        var items_length = _buf.ReadShort();
        for (var i = 0; i < items_length; i++) {
            this.items[i] = _buf.ReadBean(TempItemInfo);
        }
        this.luckyDrawType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.luckydraw.RecvResLuckyDrawResultGameToClientMessage(this);
	},

});
////////////////////
// 返回个人抽奖记录 //
////////////////////
var ResShenJiBoxLuckyDrawRecordToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.records = []; // 奖励记录列表 DrawRecordInfo
        this.luckyDrawType = 0; // 抽奖类型
	},

	getId:function(){
		return 167103;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.records.length );
        for (var i = 0; i < this.records.length; i++) {
            _buf.WriteBean(this.records[i]);
        }
        _buf.WriteVarInt(this.luckyDrawType);
	},
	
	reading:function( _buf ){
        var records_length = _buf.ReadShort();
        for (var i = 0; i < records_length; i++) {
            this.records[i] = _buf.ReadBean(DrawRecordInfo);
        }
        this.luckyDrawType = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.luckydraw.RecvResShenJiBoxLuckyDrawRecordToClinetMessage(this);
	},

});
////////////////////
// 告诉前端可用抽奖次数(充值抽奖等) //
////////////////////
var ResLuckyDrawOwnNumsToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.ownNums = []; // 类型对应的可抽奖次数(类型-次数) int
	},

	getId:function(){
		return 167104;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteShort( this.ownNums.length );
        for (var i = 0; i < this.ownNums.length; i++) {
            _buf.WriteVarInt(this.ownNums[i]);
        }
	},
	
	reading:function( _buf ){
        var ownNums_length = _buf.ReadShort();
        for (var i = 0; i < ownNums_length; i++) {
            this.ownNums[i] = _buf.ReadVarInt();
        }
	},

	action:function(){
		Mgr.luckydraw.RecvResLuckyDrawOwnNumsToClinetMessage(this);
	},

});
////////////////////
// 发送奖池元宝数量 //
////////////////////
var ResPrizePoolEnetrYanbaoNumToClinetMessage = cc.Class.extend( {
	ctor:function(){
		this.luckyDrawType = 0; // 抽奖类型
        this.prizePoolEnetrYanbaoNum = 0; // 奖池元宝数量
	},

	getId:function(){
		return 167105;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.luckyDrawType);
        _buf.WriteVarInt(this.prizePoolEnetrYanbaoNum);
	},
	
	reading:function( _buf ){
        this.luckyDrawType = _buf.ReadVarInt();
        this.prizePoolEnetrYanbaoNum = _buf.ReadVarInt();
	},

	action:function(){
		Mgr.luckydraw.RecvResPrizePoolEnetrYanbaoNumToClinetMessage(this);
	},

});
////////////////////
// 抽奖面板信息 //
////////////////////
var ReqLuckyDrawInfoClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.luckyDrawType = 0; // 抽奖类型
	},

	getId:function(){
		return 167201;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.luckyDrawType);
	},
	
	reading:function( _buf ){
        this.luckyDrawType = _buf.ReadVarInt();
	},

});
////////////////////
// 请求开始抽奖 //
////////////////////
var ReqLuckyDrawPerformClientToGameMessage = cc.Class.extend( {
	ctor:function(){
		this.luckyDrawType = 0; // 抽奖类型
        this.num = 0; // 抽奖次数(前端自己传数据来1到XXX)
	},

	getId:function(){
		return 167202;
	},
		
	writeSendHead:function( _buf, sendMsgNum, serverChkTime ){
		_buf.WriteInt( sendMsgNum );
		_buf.WriteInt( this.getId() );
		_buf.WriteInt( serverChkTime );
	},
	
	writing:function( _buf ){
		_buf.WriteVarInt(this.luckyDrawType);
        _buf.WriteVarInt(this.num);
	},
	
	reading:function( _buf ){
        this.luckyDrawType = _buf.ReadVarInt();
        this.num = _buf.ReadVarInt();
	},

});
// 接收消息注册
MESSAGE_POOL.Add(167101, ResLuckyDrawInfoGameToClientMessage);
MESSAGE_POOL.Add(167102, ResLuckyDrawResultGameToClientMessage);
MESSAGE_POOL.Add(167103, ResShenJiBoxLuckyDrawRecordToClinetMessage);
MESSAGE_POOL.Add(167104, ResLuckyDrawOwnNumsToClinetMessage);
MESSAGE_POOL.Add(167105, ResPrizePoolEnetrYanbaoNumToClinetMessage);

