//拾取管理
var PickMgr = PickMgr||cc.Class.extend({
        propHs:null,                  //周围东西表
        CanPickProp:null,             //可以捡的东西表
        itemId:null,                  //正在捡的物品
        UpdateId:null,                 //自动拾取
        maxDistance:1000,                 //捡东西的最大距离
        protectedTime:20,              //掉落保护时间
        ctor:function() {
            //自动捡东西的时间表
            this.UpdateId = TimerUtil.TimeUpdate(this.OnFrame,this,1);
            this.propHs = new HashMap();
            this.CanPickProp = new HashMap();
        },
        //新出现的物品
        AddItem:function(item){
            this.propHs.Put(item.nGid,item);
            Mgr.backpack.dropItems.Put(item.oSid,item);
        },
        DeleteItem:function(id){
            this.propHs.Remove(id);
            this.CanPickProp.Remove(id);
        },
        PickPropItem:function(prop){
            //判断 坐标
            this.itemId=prop.oSid;
            if(prop.x==Mgr.mainPlayer.x&&prop.y==Mgr.mainPlayer.y)
            {
                //直接拾取
                this.PickProp();
            }
            else {
                //寻路再拾取
                if(!Mgr.mainPlayer.IsCanDoRun()) {
                    return;
                }
                var gridPt = ToolMap.Pos2GridPt(cc.p(prop.x,-prop.y));
                Mgr.mainPlayer.oCtrlAutoPath.RunToPt(gridPt,AutoPathParam.CreateCallBack(this.PickProp,this));
            }
        },
        PickProp:function(){
            var list = Mgr.backpack.dropItems.Values();
            var itemIds = [];
            for(var i = 0; i<list.length;i++)
            {
                var item = Q_item.Get(list[i].itemModelId);
                var bool = Mgr.plugset.IsAutoPickByType(item.q_type);
                if(bool)
                {
                    itemIds.push(list[i].oSid);
                }
            }
            Mgr.backpack.SendReqTakeUpMessage(itemIds);
        },
        //手动拾取
        PickPropItemByHand:function(prop){
            //判断 坐标
            this.itemId=prop.oSid;
            if(prop.x==Mgr.mainPlayer.x&&prop.y==Mgr.mainPlayer.y)
            {
                //直接拾取
                this.PickProp();
            }
            else {
                //寻路再拾取
                if(!Mgr.mainPlayer.IsCanDoRun()) {
                    return;
                }
                var gridPt = ToolMap.Pos2GridPt(cc.p(prop.x,-prop.y));
                Mgr.mainPlayer.oCtrlAutoPath.RunToPt(gridPt,AutoPathParam.CreateCallBack(this.PickPropByHand,this));
            }
        },
        PickPropByHand:function()
        {
            Mgr.backpack.SendReqTakeUpMessage([Mgr.pickMgr.itemId]);
            Mgr.pickMgr.DeleteItem(Mgr.pickMgr.itemId.toGID());
        },
        //检查有没有可以捡起来的东西
        CheckItem:function(){
            var propList = this.propHs.Values();
            for(var i=0;i<propList.length;++i){
                var item=propList[i];
                var distance = Math.sqrt(Math.pow(Mgr.mainPlayer.x-item.x,2)+Math.pow(Mgr.mainPlayer.y-item.y,2));
                if(distance<this.maxDistance) {
                    if (item.ownerId == 0 || TimerUtil.GetTimer() - item.dropTime > this.protectedTime) {
                        this.propHs.Remove(item.nGid);
                        this.CanPickProp.Put(item.nGid, item);
                    }
                }
            }
        },
        CloseAuto: function () {
            var list = this.CanPickProp.Values();
            for(var i=0;i<list.length;++i){
                this.propHs.Put(list[i].nGid,list[i]);
            }
            this.CanPickProp.Clear();
        },
        OnFrame:function(){
            if(!Mgr.plugset.GetPlugSetInfo().pickup)
            {
                return;
            }
            if(!Mgr.mainPlayer) return;
            if(Mgr.mainPlayer.IsActiveState()) return;
            this.CheckItem();
            if(!Mgr.backpack.GetEmptyGrid())
                return;
            var item = this.CanPickProp.Values()[0];
            if(item) {
                this.PickPropItem(item);
            }
        }
    });
