var ShuTongPanelExt = ShuTongPanel.extend ( {
	_className:"ShuTongPanelExt",

	panelMgr:null,
	showPanel:null,
	showType:null,

	ctor:function(){
		this._super();
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.isShowTween = true;
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = 10;
		this.showType = EnumResline.SHUTONG;

		this.panelMgr = {};

        /// 注册新功能开放监听
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_SHUTONG,BtnGroupUtil.SHUTONG_SHUTONG);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_SHUTONG,BtnGroupUtil.SHUTONG_RIDE);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_JINJIE,BtnGroupUtil.JINJIE_SHUTONG);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_JINJIE,BtnGroupUtil.JINJIE_BAOQI);
	},

	Init:function() {
		var self = this;
		ShuTongPanel.prototype.Init.call(this);
		this.SetPendantMovie(this.imgGuajian);

		this._InitParam();

		this.btnClose.addClickEventListener(function (event){
			if ( Mgr.resline._CheckZhuFu(self.showType) ) {    // 弹出祝福面板
				Mgr.uiMgr.ShowPanelByType( ZhufuzhiInfoExt.PanelName ).SetData(self.showType, function () {
					EngineMgr.uiMgr.HidePanel( self );
				});
			}
			else
				EngineMgr.uiMgr.HidePanel( self );
		});

		for (var i = 0; i < this._btnArr.length; i++ )
		{
			this._btnArr[i].btn.type = this._btnArr[i].type;
			this._btnArr[i].btn.addTouchEventListener(function(target,state)
			{
				if(state == ccui.Widget.TOUCH_ENDED)
				{
					if ( Mgr.resline._CheckZhuFu(self.showType) ) {    // 弹出祝福面板
						Mgr.uiMgr.ShowPanelByType( ZhufuzhiInfoExt.PanelName ).SetData(self.showType, function () {
							self.ChangePanel(target.type);
						});
					}
					else
						self.ChangePanel(target.type);
				}
			});
		}

		// this.sbtnShutong.addClickEventListener(function (event){
		// 	self.ChangePanel(EnumResline.SHUTONG);
		// });
        //
		// this.sbtnZuoqi.addClickEventListener(function (event){
		// 	self.ChangePanel(EnumResline.BAOQI);
		// });
		this.UpdataWarn();
	},

	_InitParam:function () {
		this.imgWarn.visible = false;
		this._titleArr = [this.imgTitleSt,this.imgTitleZq];
		this._btnArr = [
			{btn:this.sbtnShutong,type:EnumResline.SHUTONG, btnStr:this.labJiaose, pos:this.sbtnShutong.getPosition()},
			{btn:this.sbtnZuoqi,type:EnumResline.BAOQI, btnStr:this.labRide, pos:this.sbtnZuoqi.getPosition()},
		];
	},

	IsResline:function( value ){
		return this.showType == value;
	},

	ChangePanel:function ( type ) {
		for (var i = 0; i != this._btnArr.length; i++) {
			if (this._btnArr[i].type == type) {
				this._btnArr[i].btn.SetButtonState("check");
				this._btnArr[i].btnStr.SetColor("0xffffff");
				this._titleArr[i].visible = true;
			}
			else {
				this._btnArr[i].btn.SetButtonState("uncheck");
				this._btnArr[i].btnStr.SetColor("0xcbb386");
				this._titleArr[i].visible = false;
			}
		}

		if (this.showPanel)
			this.showPanel.visible = false;

		switch( type ){
			default:
				if ( !this.panelMgr[type] ) {
					var panel = new RidePanelExt();
					panel.InitReslineType(type);
					panel.LoadPanel();
					this.imgBg.addChild( panel );
					this.panelMgr[type] = panel;
				}
				break;
		}
		this.showType = type;
		this.showPanel = this.panelMgr[type];
		if ( this.showPanel ) {
			this.showPanel.OnShow();
			this.showPanel.visible = true;
		}
	},

	UpdataWarn:function (type) {
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			var _type = this._btnArr[i].type;
			var _button = this._btnArr[i].btn;
			if ( type == undefined ||  _type == type ) {
				// main
				this.SetButtonWarn(_button, Mgr.player.IsMarkBySubType2( _type ));

				// sub
				var page = this.panelMgr[_type];
				if ( page && page.visible && page.UpdataWarn )
					page.UpdataWarn();
			}
		}
	},

	SetButtonWarn:function ( widget, warn ) {
		if ( !widget.warn ) {
			var icon = new MUIImage();
			icon.ParseJson(this.imgWarn.jsonobj);
			icon.Init();
			icon.setPosition(this.imgWarn.getPosition());
			widget.addChild(icon);
			widget.warn = icon
		}
		widget.warn.visible = warn;
	},

    OnNewFuncOpened:function(main,sub){
        this._ReposBtns();
    },
    OnNewFuncOpenedAndChangePanel:function(main,sub){
        if(!main || ! sub) return;
        var type
        switch(main){
            case BtnGroupUtil.M_SHUTONG:
                switch(sub){
                    case BtnGroupUtil.SHUTONG_SHUTONG:  type = EnumResline.SHUTONG;break;
                    case BtnGroupUtil.SHUTONG_RIDE:     type = EnumResline.BAOQI;break;
                }
                break;
            case BtnGroupUtil.M_JINJIE:
                switch(sub){
                    case BtnGroupUtil.JINJIE_SHUTONG:  type = EnumResline.SHUTONG;break;
                    case BtnGroupUtil.JINJIE_BAOQI:     type = EnumResline.BAOQI;break;
                }
                break;
        }

        if(!type) return;
        this.ChangePanel(type);
    },

	OnShow:function () {
		var list = this._ReposBtns();
		this.showType = this._RepanelType(this.showType, list);
		if ( this.showType == null ) {
			Mgr.tips.ShowNotice("没有开放功能");
			return;
		}
		this.ChangePanel(this.showType)
	},

	_RepanelType:function (showType,openTyps) {
		var type = null;
		if ( openTyps.length == 0 )
			return type;

		for ( var i = 0; i != openTyps.length; i++ ) {
			if ( openTyps[i] == showType ){
				type = showType;
				break;
			}
		}
		if ( type == null ) {
			type = openTyps[0];
		}
		return type;
	},

	/**按钮重排*/
	_ReposBtns:function(){
		var attr = [];
		var types = [];
		for (var i = 0; i < this._btnArr.length; i++ ) {
			var type = this._btnArr[i].type;
			// 移除
			if ( this._btnArr[i].btn.parent )
				this._btnArr[i].btn.removeFromParent();

			var main = BtnGroupUtil.M_JINJIE;
			var sub;
			if ( type == EnumResline.SHUTONG )
				sub = BtnGroupUtil.JINJIE_SHUTONG;
			else if ( type == EnumResline.BAOQI )
				sub = BtnGroupUtil.JINJIE_BAOQI;

			if (BtnGroupUtil.IsFunctionOpen(main, sub)) {
				attr.push(this._btnArr[i]);
				types.push(this._btnArr[i].type);
			}
		}
		for (var i = 0; i < attr.length; i++ ) {
			attr[i].btn.setPosition(attr[i].pos);
			this.addChild(attr[i].btn);
		}
		return types;
	},
} );
ShuTongPanelExt.PanelName = "ShuTongPanelExt";
PanelClassDic["ShuTongPanelExt"] = ShuTongPanelExt;
