var RechargePanelExt = RechargePanel.extend ( {
	_className:"RechargePanelExt",

	panelMgr:null,
	showPanel:null,
	showType:null,

	_titleArr:null,
	_btnArr:null,
	_btnPosArr:null,

	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
		this.layoutCom.layoutOffy = -30;
		this.modelPanelType = MUIPanelModelType.BLUR;
		this.panelMgr = {};

        /// 注册新功能开放监听
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_RECHARGE,BtnGroupUtil.RECHARGE_VIP);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_RECHARGE,BtnGroupUtil.RECHARGE_GOLDINVEST);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_RECHARGE,BtnGroupUtil.RECHARGE_CHANGWAN);
        BtnGroupUtil.registerNewFuncOpenedCallback(this,BtnGroupUtil.M_RECHARGE,BtnGroupUtil.RECHARGE_RECHARGE);
	},

	Init:function() {
		var self = this;
		RechargePanel.prototype.Init.call(this);

        UIUtil.SetRedTipVisible(this.imgWarn, false);


		this._InitParam();

		this.imgRecharge.addClickEventListener(function (event) {
			self.ChangePanel(RechargeTypeEnum.TYPE_RECHARGE);
		});
		this.imgGoldenInvest.addClickEventListener(function (event) {
			self.ChangePanel(RechargeTypeEnum.TYPE_INVEST_GOLEDEN);
		});
		this.imgCardInvest.addClickEventListener(function (event) {
			self.ChangePanel(RechargeTypeEnum.TYPE_CHANGWAN);
		});
		this.imgVip.addClickEventListener(function (event) {
			self.ChangePanel(RechargeTypeEnum.TYPE_VIP);
		});

		this.btnClose.addClickEventListener(function (event){
			EngineMgr.uiMgr.HidePanel( self );
		});

		var opens = this._ReposBtns();
		if ( opens.length > 0 )
			this.ChangePanel( opens[0].type );
		else
			zz.Error("没有子功能开放!");
	},

	_InitParam:function () {
		this._titleArr = [this.imgTitleVip, this.imgTitleGoldInvest, this.imgTitleCardInves, this.imgTitleRecharge];
		this._btnPosArr = [
			this.imgVip.getPosition(),this.imgGoldenInvest.getPosition(),
			this.imgCardInvest.getPosition(),this.imgRecharge.getPosition()
		];
		this._btnArr = [
			{btn:this.imgVip,type:RechargeTypeEnum.TYPE_VIP, btnStr:this.labVip},
			{btn:this.imgGoldenInvest,type:RechargeTypeEnum.TYPE_INVEST_GOLEDEN, btnStr:this.labZhanjia},
			{btn:this.imgCardInvest,type:RechargeTypeEnum.TYPE_CHANGWAN, btnStr:this.labYueka},
			{btn:this.imgRecharge,type:RechargeTypeEnum.TYPE_RECHARGE, btnStr:this.labGuangyi},
		];
	},

	ChangePanel:function ( type ){
		// statues
		for ( var i = 0; i != this._btnArr.length; i++ ) {
			if ( this._btnArr[i].type == type ) {
				this._btnArr[i].btn.SetButtonState( "check" );
				this._titleArr[i].visible = true;
				this._btnArr[i].btnStr.SetColor("0xffffff");
			}
			else {
				this._btnArr[i].btn.SetButtonState( "uncheck" );
				this._titleArr[i].visible = false;
				this._btnArr[i].btnStr.SetColor("0xcbb386");
			}
		}

		if ( this.showPanel )
			this.showPanel.visible = false;

		switch( type ){
			case RechargeTypeEnum.TYPE_RECHARGE:
				if ( !this.panelMgr[type] ) {
					var panel = new RechargeRebatePanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case RechargeTypeEnum.TYPE_INVEST_GOLEDEN:
				if ( !this.panelMgr[type] ) {
					var panel = new GoldenInvestPanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			case RechargeTypeEnum.TYPE_CHANGWAN:
				if ( !this.panelMgr[type] ) {
					var panel = new MonthCardInvestPanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}

				break;
			case RechargeTypeEnum.TYPE_VIP:
				if ( !this.panelMgr[type] ) {
					var panel = new VipInfoPanelExt();
					panel.LoadPanel();
					this.imgBg.addChild(panel);
					this.panelMgr[type] = panel;
				}
				break;
			default:
				break;
		}
		this.showType = type;
		this.showPanel = this.panelMgr[type];
		if ( this.showPanel ) {
			this.showPanel.OnShow();
			this.showPanel.visible = true;
		}
	},

	/**按钮重排*/
	_ReposBtns:function(){
		var attr = [];
		for (var i = 0; i < this._btnArr.length; i++ ) {
			var type = this._btnArr[i].type;
			var button = this._btnArr[i].btn;
			// 移除
			if ( button.parent )
				button.removeFromParent();

			var main = BtnGroupUtil.M_RECHARGE;
			var sub;
			if ( type == RechargeTypeEnum.TYPE_VIP ) 
				sub = BtnGroupUtil.RECHARGE_VIP;
			else if ( type == RechargeTypeEnum.TYPE_INVEST_GOLEDEN )
				sub = BtnGroupUtil.RECHARGE_GOLDINVEST;
			else if ( type == RechargeTypeEnum.TYPE_CHANGWAN )
				sub = BtnGroupUtil.RECHARGE_CHANGWAN;
			else if ( type == RechargeTypeEnum.TYPE_RECHARGE )
				sub = BtnGroupUtil.RECHARGE_RECHARGE;

			if (BtnGroupUtil.IsFunctionOpen(main, sub))
            	attr.push(this._btnArr[i]);
		}
		for (var i = 0; i < attr.length; i++ ) {
			attr[i].btn.setPosition(this._btnPosArr[i]);
			this.addChild(attr[i].btn);
		}
		return attr;
	},

    OnNewFuncOpened:function(main,sub){
        this._ReposBtns();
    },
    OnNewFuncOpenedAndChangePanel:function(main,sub){
        if(!main || ! sub) return;
        var type
        switch(main){
            case BtnGroupUtil.M_RECHARGE:
                switch(sub){
                    case BtnGroupUtil.RECHARGE_VIP:         type = RechargeTypeEnum.TYPE_VIP;break;
                    case BtnGroupUtil.RECHARGE_GOLDINVEST:  type = RechargeTypeEnum.TYPE_INVEST_GOLEDEN;break;
                    case BtnGroupUtil.RECHARGE_CHANGWAN:    type = RechargeTypeEnum.TYPE_CHANGWAN;break;
                    case BtnGroupUtil.RECHARGE_RECHARGE:    type = RechargeTypeEnum.TYPE_RECHARGE;break;
                }
            break;
        }

        if(!type) return;
        this.ChangePanel(type);
    },
	OnShow:function () {
	    this._ReposBtns();
		this.ChangePanel(this.showType);
	},

    UpdateVipWarn:function(bool){
        UIUtil.SetRedTipVisible(this.imgWarn, bool);
    },
} );
RechargePanelExt.PanelName = "RechargePanelExt";
PanelClassDic["RechargePanelExt"] = RechargePanelExt;
