var ShouChongMainExt = ShouChongMain.extend ( {
	_className:"ShouChongMainExt",

	buttonPanel:null,
	awardPanel:null,
	heightMargin:3,
	buttonList:[],
	awardList:[],
    model:null,
    _curActivity:null,

	ctor:function(){
		this._super();
		this.layoutCom.layoutType = MLLAYOUT_C;
        this.modelPanelType = MUIPanelModelType.BLUR;
        this.isShowTween = true;
	},

	Init:function () {
	    var self = this;
        ShouChongMain.prototype.Init.call(this);

        this.buttonList = [this.sbtnAnniu, this.sbtnAnniu10, this.sbtnAnniu30, this.sbtnAnniu50, this.sbtnAnniu100];
        this.warnList = [this.imgCue1, this.imgCue2, this.imgCue3, this.imgCue4, this.imgCue5];
        this.sbtnAnniu.label = this.labShouChong1;
        this.sbtnAnniu10.label = this.labShouChong10;
        this.sbtnAnniu30.label = this.labShouChong30;
        this.sbtnAnniu50.label = this.labShouChong50;
        this.sbtnAnniu100.label = this.labShouChong100;
        for( let i = 0, len = this.buttonList.length; i < len; i++ ){
            (function(a){
                self.buttonList[a].addClickEventListener(function(){
                    self.UpdatePanel(self.activityList[a]);
                });
            })(i);
        }
        this.awardList = [ this.gridKuang, this.gridKuang1, this.gridKuang2, this.gridKuang3, this.gridKuang4];

        this.imglabNum.y -= 25;//战斗力label位置手动调整

		this.btnClose.addClickEventListener(function (event) {
			EngineMgr.uiMgr.HidePanel(self);
        });

		this.btnRecharge.addClickEventListener(function (event) {
		    var btnState = self._curActivity.status;

		    switch (btnState){
                case 0://已领取
                    break;
                case 1://领取奖励
                    Mgr.dailyactivity.SendReqDailyActivitiesGetRewardMessage(self._curActivity.activityId);
                    break;
                case 2://不能领取，充值
                    var panel = EngineMgr.uiMgr.ShowPanelByType(RechargePanelExt.PanelName);
                    panel.ChangePanel(RechargeTypeEnum.TYPE_RECHARGE);
                    break;
            }
        });
    },
    
    SetActivityKey:function (mainPanelKey, mainPanelType, isOpen) {
        isOpen = isOpen || false;
        this.mainPanelKey = mainPanelKey;
        this.UpdateActivityInfo(isOpen);
    },

    UpdateActivityInfo:function(isOpen){
        var list = Mgr.dailyactivity.GetActivityByKey(this.mainPanelKey);
        this.activityList = list;
        for(var i = 0; i < list.length; i++){
            this.warnList[i].activityId = this.activityList[i].activityId;
            if(this.activityList[i].status == 1)
                this.warnList[i].visible = true;
            else
                this.warnList[i].visible = false;
        }

        for(var i = list.length; i < this.buttonList.length; i++){
            var button = this.buttonList[i];
            button.removeFromParent();
        }
        if( isOpen ){
            this.buttonList[0].SetButtonState(MUICheckBox.STATE_CHECK , true);
            this.UpdatePanel(list[0]);
        }
    },

    //刷新单个活动
    UpdateSingleActivity:function(info){
        if( this._curActivity && info.activityId === this._curActivity.activityId ){
            this.UpdatePanel(info);
        }
        for(var i = 0; i < this.warnList.length; i++){
            if(this.warnList[i].activityId == info.activityId){
                if(info.status == 1)
                    this.warnList[i].visible = true;
                else
                    this.warnList[i].visible = false;
            }
        }
    },

    //设置领奖按钮的属性
    SetPublicButtonText:function (status) {
        switch (status){
            case 0:
                this.btnRecharge.setTitleText("已领取");
                Filter.GrayScale(this.btnRecharge);
                break;
            case 1:
                this.btnRecharge.setTitleText("领取奖励");
                Filter.UnGray(this.btnRecharge);
                break;
            case 2:
                this.btnRecharge.setTitleText("充点小钱玩一玩");
                Filter.UnGray(this.btnRecharge);
                break;
        }
    },

    UpdateRewards:function(){
        var awards = JSON.parse(this._curActivity.activityReward);
        for(var i = 0, len = awards.length; i < len; i++){//生成奖励列表
            var award = this.awardList[i];
            if(award){
                var awardInfor = awards[i];
                var item = ItemUtil.ItemIdToItem(awardInfor.mod, awardInfor.num, awardInfor.bind);
                GridUtil.SetItemGrid(award, item);
            }
        }

        for(var i = awards.length; i < this.awardList.length; i++){
            var cell = this.awardList[i];
            this.awardPanel.removeChild(cell);
        }
    },

    UpdateUIModel:function(){
        var info = this._curActivity;

        if( !this.model ){
            this.model = new MAnimationObject();
            this.model.scale = 1.2;
            this.imgModel.addChild(this.model);
        }
        var showType = info.GetFlagValue("paneltype");
        var id = info.GetFlagValue("id");
        var url = null;
        switch (showType){
            case "1":
                url = "res/animation/effect/ui/roleshow/player/"+id;
                this.model.SetResUrlBase(url);
                this.model.DoAction("stand");
                break;
            case "2":
                url = "res/animation/effect/ui/"+id;
                this.model.SetResUrlBase(url);
                this.model.DoAction("stand5");
                break;
        }

        switch (id){//手动调整展示资源的位置
            case "1131": this.model.setPosition(0,0); break;//任意金额奖励，下面依次
            case "1134": this.model.setPosition(0,0); break;
            case "91": this.model.setPosition(0,-10); break;
            case "2089": this.model.setPosition(0,120); break;
            case "93": this.model.setPosition(0,120); break;
        }
    },

    //刷新面板信息
    UpdatePanel:function (info) {
        this._curActivity = info;

        this.UpdateRewards();
        this.SetPublicButtonText(info.status);
        this.imglabNum.SetText(info.GetFlagValue(EnumActivityFlag.F_POWER));
        UIUtil.LoadImage( this.imgZi, "other/shouchong/word/" + info.GetFlagValue(EnumActivityFlag.F_BACKGROUND));
        this.UpdateUIModel();
    },

    OnShow:function(){
        this._super();
    },

    OnHide:function(){
        this._super();
        if( this.model )
            this.model.Dispose();
        this.model = null;
    }
} );
ShouChongMainExt.PanelName = "ShouChongMainExt";
PanelClassDic["ShouChongMainExt"] = ShouChongMainExt;
