/*
 * 任务util
 */
var EnumTaskType = EnumTaskType || {
    // 主线任务
    TYPE_MAIN : 1,
    // 日常任务
    TYPE_DAY : 2,
    // 帮派日常任务
    TYPE_GUILD : 3,
    // 悬赏
    CONQUER : 4,
    //支线任务
    TYPE_BRANCH : 5,

    // 护送_客户端专用
    CLIENT_CONVOY : -1,
};

var NpcSubTaskType = NpcSubTaskType || {};
//对话类型
NpcSubTaskType.TASK_TALK = 1;
//杀怪数量
NpcSubTaskType.TASK_MONSTER = 2;
//杀怪获得道具  ====这种条件的检测是自己从包裹里查询，其余都是从服务端发来数据进行检测
NpcSubTaskType.TASK_MONSTER_PROPS = 3;
//采集获得道具
NpcSubTaskType.TASK_COLLECT_PROPS = 4;
//使用道具完成任务
NpcSubTaskType.TASK_USE_PROPS = 5;
//进入副本
NpcSubTaskType.TASK_ZONE = 6;
//副本通关
NpcSubTaskType.TASK_PASS_ZONE = 7;

var EnumTaskState = EnumTaskState || {
    // 未领取
    STATE_UNGET : 0,   //目前不包含此状态
    // 进行中
    STATE_RUNNING : 1,
    // 未提交
    STATE_UNSUBMIT : 2,
};

var TaskCondition = TaskCondition || cc.Class.extend({
        conditionId:0,
        num:0,
        mapId:0,
        pos:null,
        ctor:function( taskId ){
            var taskData = Q_mission_base.Get(taskId);
            if ( !taskData )
                return;
            if (taskData.q_pathing) {
                var pathstrArr = taskData.q_pathing.split(';');
                for (var i = 0; i < pathstrArr.length; i++) {
                    if( i == 0 || Math.random > 0.5 ){
                        var pathsArr = pathstrArr[i].split( "," );
                        if( pathsArr.length >= 3 ){
                            this.mapId = parseInt(pathsArr[0]);
                            this.pos = new cc.p( parseInt(pathsArr[1]), parseInt(pathsArr[2]) );
                            if( pathsArr.length > 3 )
                                this.conditionId = parseInt(pathsArr[3]);
                        }
                    }
                }
            }
            //完成条件
            if( taskData.q_finish_information_str ){
                var finnishC = taskData.q_finish_information_str.split(",");
                if (finnishC.length <= 1)
                    return;

                this.conditionId = parseInt(finnishC[0]);
                this.num = parseInt(finnishC[1]);
            }
        }
    });

var TaskUtil = TaskUtil || {

    //取得任务q_pathing : mapid 、pt
    GetTaskCondition:function (taskmid) {
        return new TaskCondition(taskmid);
    },

    /**
     * 检查任务是否完成，目标全部达到
     * @param info
     * @return
     *
     */
    CheckTaskComplate:function (taskmid, taskmsg) {
        var taskm = Q_mission_base.Get(taskmid);
        if (!taskm || taskm.length == 0)
            return;

        if ( !Mgr.task.GetTaskInfo(taskmid) )
            return EnumTaskState.STATE_UNGET; // 对话型视为 未提交

        if (taskm.q_mission_type == NpcSubTaskType.TASK_TALK)
            return EnumTaskState.STATE_UNSUBMIT; // 对话型视为 未提交

        var parseData = taskm.q_finish_information_str.split( ";" );
        if (!parseData)
            return;

        if (taskmsg.taskSubType == NpcSubTaskType.TASK_MONSTER_PROPS) { //杀怪获得道具从背包中判断道具个数
            // var num = Mgr.backpackMgr.getItemNumber(parseData[0]);
            // if (num < parseData[1])
            //  return false;
        }

        var vec = taskmsg.taskSubRateInfolist;
        if (vec && vec.length == parseData.length ) {
            for(var j = 0; j < parseData.length; j++) {
                var arr = parseData[j].split(",");
                for (var i = 0; i < vec.length; i++) {
                    if (vec[i].modelId == arr[0]) {
                        if (vec[i].num < parseInt(arr[1]))
                            return EnumTaskState.STATE_RUNNING;  //进行中
                    }
                }
            }
            return EnumTaskState.STATE_UNSUBMIT;
        }
        else { //当进度为0时，后端发来的进度列表是个空列表
            return EnumTaskState.STATE_RUNNING;
        }
    },

    /**
     * 返回任务完成进度
     * @param info
     * @return
     *
     */
    GetTaskComplate:function (taskmid, taskmsg) {
        var rate = [1,1];

        var taskm = Q_mission_base.Get(taskmid);
        if (!taskm || taskm.length == 0)
            return;

        if (taskm.q_mission_type == NpcSubTaskType.TASK_TALK)
            return rate;

        var parseData = taskm.q_finish_information_str.split( ";" );
        if (!parseData)
            return;

        var rate = [];
        for(var j = 0; j < parseData.length; j++){
            var arr = parseData[j].split(",");
            var modelId = arr[0];
            arr[0] = 0;
            arr[1] = parseInt(arr[1]);
            var vec = taskmsg.taskSubRateInfolist;
            if (vec && vec.length > 0 ) {
                for (var i = 0; i < vec.length; i++) {
                    if (vec[i].modelId == modelId) {
                        arr[0] = vec[i].num;
                        break;
                    }
                }
            }
            rate.push(arr);
        }
        return rate;
    },

    GetNpcIdByTask:function( taskId, state ){
        var id = 0;
        var mission = Q_mission_base.Get( taskId );
        if( mission ){
            var segId = 0;
            if( state == EnumTaskState.STATE_UNGET )
                segId = mission.q_receive_mission;
            else
                segId = mission.q_deal_mission;
            id = this.GetNpcIdBySegment(segId);
        }
        return id;
    },

    GetNpcIdBySegment:function ( segId ) {
        var id = 0;
        var s = Q_mission_segment.Get( segId );
        if( s )
            id = s.q_mission_npc;
        return id;
    },

    GetTaskType:function( modelId ){
        var m = Q_mission_base.Get( modelId );
        if( m )
            return m.q_mission_mainType;
        return 0;
    },

    /**
     * 特殊任务相关
     * @param taskid
     * @constructor
     */
    DoSpecialTask:function( taskId ){
        switch( taskId ){
            case 10030:
                Mgr.zone.SendReqZoneEnterToGameMessage( 10001 );
                break;
            case 10072:
                Mgr.zone.SendReqZoneEnterToGameMessage( 10002 );
                break;
            default:
            	return false;
        }
        return true;
    },

    DoCommandTransfer:function( taskId ){
        // var npcId = this.GetNpcIdByTask(taskId, EnumTaskState.STATE_UNSUBMIT);
        // if( npcId ) {
        //     var npc = Q_npc.Get(npcId);
        //     if( Mgr.sceneMap.nMapId == npc.q_map ){
        //         Mgr.mainPlayer.oCtrlAutoPath.MoveByCrossMap(npc.q_map, new cc.p( npc.q_x, npc.q_y), AutoPathParam.CreateSelectNpc(npcId));
        //     }
        //     else {
        //         Mgr.map.SendReqTaskMoveToGameMessage( taskId, 0 );
        //     }
        // }
    }
}